# BipartiteGraphs.jl

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

This package provides a litany of types and utilities for working with bipartite graphs.

using BipartiteGraphs
using Graphs
using Test

@testset "Construction" begin
    fadjlist = [[1, 2], [2, 3], [3]]
    g = BipartiteGraph(fadjlist, 3)

    # Empty matching
    dmog = DiCMOBiGraph{false}(g)
    @test dmog.graph === g
    @test length(dmog.matching) == 3

    # With matching
    m = Matching(3)
    m[1] = 1
    m[2] = 2
    dmog2 = DiCMOBiGraph{false}(g, m)
    @test dmog2.matching === m
end

@testset "Graph properties" begin
    fadjlist = [[1, 2], [2, 3], [3]]
    g = BipartiteGraph(fadjlist, 3)
    m = Matching(3)
    m[1] = 1
    m[2] = 2
    m[3] = 3

    dmog = DiCMOBiGraph{false}(g, m)
    @test is_directed(dmog)
    @test nv(dmog) == 3
    @test vertices(dmog) == 1:3
end

@testset "Neighbors (non-transposed)" begin
    fadjlist = [[1, 2], [2, 3], [3]]
    g = BipartiteGraph(fadjlist, 3)
    m = Matching(3)
    m[1] = 1
    m[2] = 2
    m[3] = 3

    dmog = DiCMOBiGraph{false}(complete(g), m)

    # Out-neighbors (non-matched edges from src)
    out_neighbors_1 = collect(outneighbors(dmog, 1))
    @test 2 in out_neighbors_1  # Edge 1->2 exists and is not matched

    # Test edges
    edges_list = collect(edges(dmog))
    @test all(e -> e isa Graphs.AbstractEdge, edges_list)
end

@testset "Neighbors (transposed)" begin
    fadjlist = [[1, 2], [2, 3], [3]]
    g = BipartiteGraph(fadjlist, 3)
    m = Matching(3)
    m[1] = 1
    m[2] = 2

    dmog = DiCMOBiGraph{true}(complete(g), m)
    @test nv(dmog) == 3  # Should have ndsts vertices
end

@testset "invview" begin
    fadjlist = [[1, 2], [2]]
    g = BipartiteGraph(fadjlist, 2)
    m = Matching(2)
    m[1] = 1
    m = complete(m, 2)  # Complete the matching

    dmog = DiCMOBiGraph{false}(complete(g), m)
    dmog_inv = invview(dmog)

    @test dmog_inv isa DiCMOBiGraph{true}
end

@testset "has_edge" begin
    fadjlist = [[1, 2], [2, 3]]
    g = BipartiteGraph(fadjlist, 3)
    m = Matching(3)
    m[1] = 1
    m[2] = 2

    dmog = DiCMOBiGraph{false}(complete(g), m)

    # Check for directed edges based on matching
    # This is complex due to the orientation rules
    @test has_edge(dmog, 1, 2) || !has_edge(dmog, 1, 2)  # Just check it doesn't error
end

@testset "Edge operations" begin
    fadjlist = [[1, 2], [2, 3], [1, 3]]
    g = BipartiteGraph(fadjlist, 3)
    m = Matching(3)
    m[1] = 1
    m[2] = 2
    m[3] = 3

    dmog = DiCMOBiGraph{false}(complete(g), m)

    # Test ne calculation
    num_edges = ne(dmog)
    @test num_edges >= 0

    # Test edge existence
    edges_list = collect(edges(dmog))
    @test length(edges_list) >= 0
end

@testset "Transposed graph operations" begin
    fadjlist = [[1, 2], [2, 3], [3]]
    g = BipartiteGraph(fadjlist, 3)
    m = Matching(3)
    m[1] = 1
    m[2] = 2
    m[3] = 3
    m = complete(m, 3)  # Complete the matching

    dmog = DiCMOBiGraph{true}(complete(g), m)

    # Test vertices
    @test nv(dmog) == 3
    verts = vertices(dmog)
    @test length(verts) == 3

    # Test inneighbors (safer path)
    in_neighs_iter = inneighbors(dmog, 1)
    @test in_neighs_iter isa BipartiteGraphs.CMONeighbors
end

@testset "Type constructor for induced_subgraph" begin
    # Test the special constructor for SimpleDiGraph compatibility
    sg = DiCMOBiGraph(5)
    @test sg isa Graphs.SimpleDiGraph
    @test nv(sg) == 5
end

using Documenter, BipartiteGraphs
import Graphs
import SparseArrays

const ExtMod = Base.get_extension(BipartiteGraphs, :BipartiteGraphsSparseArraysExt)
const REPO_ROOT = abspath(joinpath(@__DIR__, ".."))
const REPO_REMOTE = Documenter.Remotes.GitHub("SciML", "BipartiteGraphs.jl")
const REPO_COMMIT = readchomp(`git -C $REPO_ROOT rev-parse HEAD`)

cp("./docs/Manifest.toml", "./docs/src/assets/Manifest.toml", force = true)
cp("./docs/Project.toml", "./docs/src/assets/Project.toml", force = true)

makedocs(
    sitename = "BipartiteGraphs.jl",
    authors = "Chris Rackauckas",
    modules = [BipartiteGraphs, ExtMod],
    checkdocs = :exports,
    remotes = Dict(
        REPO_ROOT => (REPO_REMOTE, REPO_COMMIT),
    ),
    clean = true, doctest = true, linkcheck = true,
    format = Documenter.HTML(;
        assets = ["assets/favicon.ico"],
        canonical = "https://docs.sciml.ai/BipartiteGraphs/stable/",
        prettyurls = (get(ENV, "CI", nothing) == "true")
    ),
    pages = [
        "Home" => "index.md",
        "api.md",
    ]
)

deploydocs(
    repo = "github.com/SciML/BipartiteGraphs.jl.git";
    push_preview = true
)

@deprecate maximal_matching(g::BipartiteGraph, srcfilter) maximal_matching(g; srcfilter)
@deprecate maximal_matching(g::BipartiteGraph, srcfilter, dstfilter) maximal_matching(g; srcfilter, dstfilter)
@deprecate maximal_matching(g::BipartiteGraph, srcfilter, dstfilter, T) maximal_matching(
    g, T; srcfilter, dstfilter
)

"""
Abstract base type for condensation graph representations.

```julia
    (::Type{<:AbstractCondensationGraph})(g, sccs::Vector{Vector{Int}})
```

Construct an [`AbstractCondensationGraph`](@ref) from a graph and strongly connected components.
"""
abstract type AbstractCondensationGraph <: AbstractGraph{Int} end
function (T::Type{<:AbstractCondensationGraph})(g, sccs::Vector{Union{Int, Vector{Int}}})
    scc_assignment = Vector{Int}(undef, isa(g, BipartiteGraph) ? ndsts(g) : nv(g))
    for (i, c) in enumerate(sccs)
        for v in c
            scc_assignment[v] = i
        end
    end
    return T(g, sccs, scc_assignment)
end
function (T::Type{<:AbstractCondensationGraph})(g, sccs::Vector{Vector{Int}})
    return T(g, Vector{Union{Int, Vector{Int}}}(sccs))
end

Graphs.is_directed(::Type{<:AbstractCondensationGraph}) = true

"""
    $TYPEDSIGNATURES

Get the number of vertices (strongly connected components) in the condensation graph.
"""
Graphs.nv(icg::AbstractCondensationGraph) = length(icg.sccs)
Graphs.vertices(icg::AbstractCondensationGraph) = Base.OneTo(nv(icg))

"""
    $TYPEDEF

For some bipartite-graph and an orientation induced on its destination contraction,
records the condensation DAG of the digraph formed by the orientation. I.e. this
is a DAG of connected components formed by the destination vertices of some
underlying bipartite graph.
N.B.: This graph does not store explicit neighbor relations of the sccs.
Therefor, the edge multiplicity is derived from the underlying bipartite graph,
i.e. this graph is not strict.
"""
struct MatchedCondensationGraph{G <: DiCMOBiGraph} <: AbstractCondensationGraph
    graph::G
    # Records the members of a strongly connected component. For efficiency,
    # trivial sccs (with one vertex member) are stored inline. Note: the sccs
    # here need not be stored in topological order.
    sccs::Vector{Union{Int, Vector{Int}}}
    # Maps the vertices back to the scc of which they are a part
    scc_assignment::Vector{Int}
end

function Graphs.outneighbors(mcg::MatchedCondensationGraph, cc::Integer)
    return Iterators.flatten(
        (
                mcg.scc_assignment[v′]
                for v′ in outneighbors(mcg.graph, v) if mcg.scc_assignment[v′] != cc
            )
            for v in mcg.sccs[cc]
    )
end

function Graphs.inneighbors(mcg::MatchedCondensationGraph, cc::Integer)
    return Iterators.flatten(
        (
                mcg.scc_assignment[v′]
                for v′ in inneighbors(mcg.graph, v) if mcg.scc_assignment[v′] != cc
            )
            for v in mcg.sccs[cc]
    )
end

"""
    $TYPEDEF

For some bipartite-graph and a topologicall sorted list of connected components,
represents the condensation DAG of the digraph formed by the orientation. I.e. this
is a DAG of connected components formed by the destination vertices of some
underlying bipartite graph.
N.B.: This graph does not store explicit neighbor relations of the sccs.
Therefor, the edge multiplicity is derived from the underlying bipartite graph,
i.e. this graph is not strict.
"""
struct InducedCondensationGraph{G <: BipartiteGraph} <: AbstractCondensationGraph
    graph::G
    # Records the members of a strongly connected component. For efficiency,
    # trivial sccs (with one vertex member) are stored inline. Note: the sccs
    # here are stored in topological order.
    sccs::Vector{Union{Int, Vector{Int}}}
    # Maps the vertices back to the scc of which they are a part
    scc_assignment::Vector{Int}
end

function _neighbors(icg::InducedCondensationGraph, cc::Integer)
    return Iterators.flatten(
        Iterators.flatten(
                icg.graph.fadjlist[vsrc]
                for vsrc in icg.graph.badjlist[v]
            )
            for v in icg.sccs[cc]
    )
end

function Graphs.outneighbors(icg::InducedCondensationGraph, v::Integer)
    return (icg.scc_assignment[n] for n in _neighbors(icg, v) if icg.scc_assignment[n] > v)
end

function Graphs.inneighbors(icg::InducedCondensationGraph, v::Integer)
    return (icg.scc_assignment[n] for n in _neighbors(icg, v) if icg.scc_assignment[n] < v)
end

using PrecompileTools: @compile_workload, @setup_workload

@setup_workload begin
    @compile_workload begin
        # Precompile BipartiteGraph construction and basic operations
        fadjlist = [[1], [1], [2], [2], [1], [1, 2]]
        badjlist = [[1, 2, 5, 6], [3, 4, 6]]

        # BipartiteGraph with full adjacency lists
        bg = BipartiteGraph(fadjlist, badjlist)

        # BipartiteGraph with just ndsts (incomplete)
        bg_incomplete = BipartiteGraph(fadjlist, 2)

        # Complete an incomplete graph
        bg_completed = complete(bg_incomplete)

        # Get vertices and edges
        𝑠vertices(bg)
        𝑑vertices(bg)
        nsrcs(bg)
        ndsts(bg)
        ne(bg)
        nv(bg)

        # Neighbors
        𝑠neighbors(bg, 1)
        𝑑neighbors(bg, 1)

        # Edge operations
        has_𝑠vertex(bg, 1)
        has_𝑑vertex(bg, 1)
        has_edge(bg, BipartiteEdge(1, 1))

        # invview
        inv_bg = invview(bg)

        # Edge iteration
        for edge in edges(bg)
        end
        for edge in 𝑠edges(bg)
        end
        for edge in 𝑑edges(bg)
        end

        # Edge collection (triggers different code paths than iteration)
        collect(edges(bg))
        collect(𝑠edges(bg))
        collect(𝑑edges(bg))

        # Vertex collection
        collect(vertices(bg))

        # Maximal matching
        m = maximal_matching(bg)

        # Matching operations
        complete(m)
        copy(m)

        # DiCMOBiGraph construction (requires complete matching for some operations)
        m_complete = complete(m, nsrcs(bg))
        dcmo = DiCMOBiGraph{false}(bg, m_complete)
        vertices(dcmo)
        nv(dcmo)
        outneighbors(dcmo, 1)
        ne(dcmo)
        collect(edges(dcmo))

        dcmo_t = DiCMOBiGraph{true}(bg, complete(m, nsrcs(bg)))
        inneighbors(dcmo_t, 1)
        outneighbors(dcmo_t, 1)
        ne(dcmo_t)
        collect(edges(dcmo_t))
        dcmo_t = DiCMOBiGraph{true}(bg, m_complete)

        # DiCMOBiGraph neighbor iteration (critical for TTFX)
        collect(outneighbors(dcmo, 1))
        collect(inneighbors(dcmo, 1))
        collect(outneighbors(dcmo_t, 1))
        collect(inneighbors(dcmo_t, 1))

        # DiCMOBiGraph edge iteration
        for edge in Graphs.edges(dcmo)
        end

        # Empty graph construction
        empty_bg = BipartiteGraph(3, 2)

        # Graph modification operations
        bg_mod = BipartiteGraph([[1, 2], [2, 3]], 3)
        bg_mod = complete(bg_mod)
        set_neighbors!(bg_mod, 1, [3])
        rem_edge!(bg_mod, 2, 2)
        add_edge!(bg_mod, 2, 2)

        # Condensation graphs
        cond_fadjlist = [[1, 2], [2, 3], [3]]
        cond_g = BipartiteGraph(cond_fadjlist, 3)
        cond_g = complete(cond_g)
        cond_m = Matching(3)
        cond_m[1] = 1
        cond_m[2] = 2
        cond_m[3] = 3
        cond_m_complete = complete(cond_m, 3)

        # MatchedCondensationGraph (requires complete matching)
        cond_dmog = DiCMOBiGraph{false}(cond_g, cond_m_complete)
        sccs = [[1], [2], [3]]
        mcg = MatchedCondensationGraph(cond_dmog, sccs)
        nv(mcg)
        vertices(mcg)
        collect(outneighbors(mcg, 1))
        collect(inneighbors(mcg, 1))

        # InducedCondensationGraph
        icg = InducedCondensationGraph(cond_g, sccs)
        nv(icg)
        vertices(icg)
        collect(outneighbors(icg, 1))
        collect(inneighbors(icg, 1))

        # HyperGraph
        hg = HyperGraph{Symbol}()
        add_vertex!(hg, :a)
        add_vertex!(hg, :b)
        add_vertex!(hg, :c)
        add_vertex!(hg, :d)
        add_edge!(hg, [:a, :b, :c])
        add_edge!(hg, [:b, :c, :d])
        vertices(hg)
        nv(hg)
        ne(hg)
        has_vertex(hg, :a)
        neighbors(hg, 1)
        incident_edges(hg, :a)
        for edge in edges(hg)
        end
        collect(edges(hg))
        connected_components(hg)
    end
end

"""
A sentinel type representing an unassigned vertex in a matching.
"""
struct Unassigned end

"""
A singleton instance representing unassigned vertices.
"""
const unassigned = Unassigned.instance

# Behaves as a scalar
Base.length(u::Unassigned) = 1
Base.size(u::Unassigned) = ()
Base.iterate(u::Unassigned) = (unassigned, nothing)
Base.iterate(u::Unassigned, state) = nothing

Base.show(io::IO, ::Unassigned) = printstyled(io, "u"; color = :light_black)

#U=> :Unassigned =#

"""
A matching between two sets of vertices in a bipartite graph. Maps destination vertices
to their matched source vertices. `U` denotes the type that unmatched variables can take.
Typically, this will be [`Unassigned`](@ref) but other types can be used for more
complicated matchings.
"""
struct Matching{U, V <: AbstractVector} <: AbstractVector{Union{U, Int}}
    match::V
    inv_match::Union{Nothing, V}
end
# These constructors work around https://github.com/JuliaLang/julia/issues/41948
"""
    $TYPEDSIGNATURES

Convert a matching to have element type `Union{V, Int}`.
"""
Matching{V}(m::Matching) where {V} = convert(Matching{V}, m)

function Base.convert(::Type{Matching{V, A}}, m::Matching) where {
        V, A <: AbstractVector{Union{V, Int}},
    }
    typeof(m) == Matching{V, A} && return m
    return Matching{V}(
        convert(A, m.match),
        m.inv_match === nothing ? nothing : convert(A, m.inv_match)
    )
end

function Base.convert(::Type{Matching{V}}, m::Matching) where {V}
    eltype(m) === Union{V, Int} && return m
    VUT = typeof(similar(m.match, Union{V, Int}, 0))
    return Matching{V}(
        convert(VUT, m.match),
        m.inv_match === nothing ? nothing : convert(VUT, m.inv_match)
    )
end

"""
    $TYPEDSIGNATURES

Identity constructor for a matching.
"""
Matching(m::Matching) = m

"""
    $TYPEDSIGNATURES

Construct a matching from a vector without the inverse matching. The inverse matching can
be calculated using [`complete`](@ref).
"""
Matching{U}(v::V) where {U, V <: AbstractVector} = Matching{U, V}(v, nothing)

"""
    $TYPEDSIGNATURES

Construct a matching from forward and inverse matchings.
"""
function Matching{U}(v::V, iv::Union{V, Nothing}) where {U, V <: AbstractVector}
    return Matching{U, V}(v, iv)
end

"""
    $TYPEDSIGNATURES

Construct a matching from a vector, inferring the unassigned type. The inverse matching
is not stored.
"""
function Matching(v::AbstractVector{T}) where {T}
    T <: Integer && return Matching{Unassigned}(v)
    Int <: T || throw(MethodError(Matching, (v,)))
    return Matching{T}(v)
end

"""
    $TYPEDSIGNATURES

Construct an empty matching with `m` vertices, all unassigned. The inverse matching is not
stored.
"""
function Matching(m::Int)
    return Matching{Unassigned}(Union{Int, Unassigned}[unassigned for _ in 1:m], nothing)
end

"""
    $TYPEDSIGNATURES

Construct an empty matching with `m` vertices and custom unassigned type `U`.
"""
function Matching{U}(m::Int) where {U}
    return Matching{Union{Unassigned, U}}(
        Union{Int, Unassigned, U}[unassigned for _ in 1:m],
        nothing
    )
end

Base.size(m::Matching) = Base.size(m.match)
Base.getindex(m::Matching, i::Integer) = m.match[i]
Base.iterate(m::Matching, state...) = iterate(m.match, state...)
function Base.copy(m::Matching{U}) where {U}
    return Matching{U}(copy(m.match), m.inv_match === nothing ? nothing : copy(m.inv_match))
end

"""
    $TYPEDSIGNATURES

Update `i` to match to `v` in matching `m`. Also updates the inverse matching, if present.
"""
function Base.setindex!(m::Matching{U}, v::Union{Integer, U}, i::Integer) where {U}
    if m.inv_match !== nothing
        oldv = m.match[i]
        # TODO: maybe default Matching to always have an `inv_match`?

        # To maintain the invariant that `m.inv_match[m.match[i]] == i`, we need
        # to unassign the matching at `m.inv_match[v]` if it exists.
        if v isa Int && 1 <= v <= length(m.inv_match) && (iv = m.inv_match[v]) isa Int
            m.match[iv] = unassigned
        end
        if isa(oldv, Int)
            @assert m.inv_match[oldv] == i
            m.inv_match[oldv] = unassigned
        end
        if isa(v, Int)
            for vv in (length(m.inv_match) + 1):v
                push!(m.inv_match, unassigned)
            end
            m.inv_match[v] = i
        end
    end
    return m.match[i] = v
end

"""
    $TYPEDSIGNATURES

Append an element to the source vertices of the matching `m`, and match it to `v`.
"""
function Base.push!(m::Matching, v)
    push!(m.match, v)
    return if v isa Integer && m.inv_match !== nothing
        for vv in (length(m.inv_match) + 1):v
            push!(m.inv_match, unassigned)
        end
        m.inv_match[v] = length(m.match)
    end
end

"""
    $TYPEDSIGNATURES

Populate the inverse matching if it is not already computed. The optional parameter `N`
specifies the size of the inverse matching vector.
"""
function complete(
        m::Matching{U},
        N = maximum((x for x in m.match if isa(x, Int)); init = 0)
    ) where {U}
    m.inv_match !== nothing && return m
    inv_match = Union{U, Int}[unassigned for _ in 1:N]
    for (i, eq) in enumerate(m.match)
        isa(eq, Int) || continue
        inv_match[eq] = i
    end
    return Matching{U}(collect(m.match), inv_match)
end

"""
    $TYPEDSIGNATURES

Throw an error if the matching does not have the inverse matching computed.
"""
@noinline function require_complete(m::Matching)
    return m.inv_match === nothing &&
        throw(ArgumentError("Backwards matching not defined. `complete` the matching first."))
end

"""
    $TYPEDSIGNATURES

Return a view of the matching with the forward and inverse matchings swapped.
Requires that the matching is [`complete`](@ref).
"""
function invview(m::Matching{U, V}) where {U, V}
    require_complete(m)
    return Matching{U, V}(m.inv_match, m.match)
end

using BipartiteGraphs
using Test

@testset "construct_augmenting_path!" begin
    # Simple matching scenario
    fadjlist = [[1], [2], [1, 2]]
    g = BipartiteGraph(fadjlist, 2)
    m = Matching(2)

    # Find augmenting path from source 1
    found = construct_augmenting_path!(m, g, 1, x -> true)
    @test found
    @test m[1] == 1

    # Reset and try from source 2
    m2 = Matching(2)
    found = construct_augmenting_path!(m2, g, 2, x -> true)
    @test found
    @test m2[2] == 2

    # Test with source 3 when dest 1 is already matched
    m3 = Matching(2)
    m3[1] = 1  # dest 1 is matched to source 1
    # Source 3 can connect to both 1 and 2, try to match to unassigned dest 2
    found = construct_augmenting_path!(m3, g, 3, x -> true)
    @test found  # Should match source 3 to dest 2 or reroute
end

@testset "maximal_matching" begin
    # Example from docs
    fadjlist = [[1], [1], [2], [2], [1], [1, 2]]
    g = BipartiteGraph(fadjlist, 2)

    m = maximal_matching(g)
    @test m isa Matching

    # Count matched vertices
    matched_count = count(x -> x isa Int, m)
    @test matched_count <= 2  # Can't match more than ndsts

    # Test with filters
    m2 = maximal_matching(g; srcfilter = s -> s <= 3, dstfilter = d -> true)
    @test m2 isa Matching

    # Test filtering out destination
    m3 = maximal_matching(g; srcfilter = s -> true, dstfilter = d -> d == 1)
    matched = [x for x in m3 if x isa Int]
    @test all(x == 1 for x in matched)
end

@testset "maximal_matching on larger graph" begin
    # More complex matching
    fadjlist = [[1, 2], [2, 3], [3, 4], [4, 5], [1, 5]]
    g = BipartiteGraph(fadjlist, 5)

    m = maximal_matching(g)
    matched_count = count(x -> x isa Int, m)
    @test matched_count >= 3  # Should find a good matching
end

using BipartiteGraphs
using Test

@testset "BipartiteGraph printing" begin
    fadjlist = [[1, 2], [2]]
    badjlist = [[1], [1, 2]]
    g = BipartiteGraph(fadjlist, badjlist)

    # Test that show doesn't error
    io = IOBuffer()
    show(io, g)
    str = String(take!(io))
    @test contains(str, "BipartiteGraph")
    @test contains(str, "2")  # number of src or dst vertices
    @test contains(str, "src")
    @test contains(str, "dst")
end

@testset "BipartiteEdge printing" begin
    e = BipartiteEdge(1, 2)
    io = IOBuffer()
    show(io, e)
    str = String(take!(io))
    @test contains(str, "src")
    @test contains(str, "dst")
    @test contains(str, "1")
    @test contains(str, "2")
end

@testset "Unassigned printing" begin
    io = IOBuffer()
    show(io, unassigned)
    str = String(take!(io))
    @test !isempty(str)
end

@testset "BipartiteAdjacencyList printing" begin
    # Test with nothing
    io = IOBuffer()
    bal = BipartiteGraphs.BipartiteAdjacencyList(nothing)
    show(io, bal)
    str = String(take!(io))
    @test !isempty(str)

    # Test with empty vector
    io = IOBuffer()
    bal = BipartiteGraphs.BipartiteAdjacencyList(Int[])
    show(io, bal)
    str = String(take!(io))
    @test !isempty(str)

    # Test with values
    io = IOBuffer()
    bal = BipartiteGraphs.BipartiteAdjacencyList([1, 2, 3])
    show(io, bal)
    str = String(take!(io))
    @test contains(str, "1")
end

@testset "Label printing" begin
    l = BipartiteGraphs.Label("test")
    io = IOBuffer()
    show(io, l)
    str = String(take!(io))
    @test contains(str, "test")
end

using BipartiteGraphs
using SciMLTesting
using Test

# ExplicitImports only inspects an extension module once it exists, which requires the
# extension's trigger package to be loaded. Without loading the weakdeps here,
# BipartiteGraphsSparseArraysExt is silently skipped by the QA checks.
using SparseArrays

# ExplicitImports silently skips an extension that fails to load, so assert the
# extension modules actually exist rather than trusting a green run_qa.
@testset "Extensions loaded" begin
    @test Base.get_extension(BipartiteGraphs, :BipartiteGraphsSparseArraysExt) !== nothing
end

run_qa(BipartiteGraphs)

using BipartiteGraphs
using Graphs
using Test

@testset "Complete workflow: graph -> matching -> DiCMO -> condensation" begin
    # Create a bipartite graph
    fadjlist = [[1], [1, 2], [2, 3], [3]]
    g = BipartiteGraph(fadjlist, 3)
    g = complete(g)

    # Find maximal matching
    m = maximal_matching(g)
    @test count(x -> x isa Int, m) >= 2

    # Create DiCMOBiGraph
    dmog = DiCMOBiGraph{false}(g, m)
    @test nv(dmog) == nsrcs(g)

    # Create simple condensation (trivial SCCs)
    sccs = [[i] for i in 1:ndsts(g)]
    mcg = MatchedCondensationGraph(dmog, sccs)
    @test nv(mcg) == ndsts(g)
end

@testset "Edge cases" begin
    # Empty graph
    g_empty = BipartiteGraph(0, 0)
    @test ne(g_empty) == 0
    @test nsrcs(g_empty) == 0
    @test ndsts(g_empty) == 0

    # Graph with no edges
    g_no_edges = BipartiteGraph(3, 2)
    @test ne(g_no_edges) == 0
    m = maximal_matching(g_no_edges)
    @test all(x -> x === unassigned, m)

    # Single vertex
    g_single = BipartiteGraph(1, 1)
    add_edge!(g_single, 1, 1)
    @test ne(g_single) == 1
    m = maximal_matching(g_single)
    @test m[1] == 1
end

@testset "Large graph stress test" begin
    # Create a larger graph
    n_src, n_dst = 100, 50
    g_large = BipartiteGraph(n_src, n_dst)

    # Add random edges
    for i in 1:n_src
        for j in 1:min(5, n_dst)
            dst = mod1(i + j, n_dst)
            add_edge!(g_large, i, dst)
        end
    end

    @test ne(g_large) > 0
    m = maximal_matching(g_large)
    @test m isa Matching
    @test length(m) >= n_dst
end

using BipartiteGraphs
using Graphs
using BipartiteGraphs: 𝑠neighbors, 𝑑neighbors, construct_augmenting_path!, _always_true, nsrcs, ndsts

@testset "Allocation Tests - Zero Allocations in Hot Paths" begin
    # Test that construct_augmenting_path! doesn't allocate when called with pre-allocated buffers
    @testset "construct_augmenting_path! zero allocations" begin
        # Create a small test graph
        g = BipartiteGraph(10, 10)
        for i in 1:10
            for j in 1:10
                if (i + j) % 3 == 0
                    Graphs.add_edge!(g, i, j)
                end
            end
        end

        matching = Matching{Unassigned}(max(nsrcs(g), ndsts(g)))
        dcolor = falses(ndsts(g))

        # Warm up
        fill!(dcolor, false)
        construct_augmenting_path!(matching, g, 1, _always_true, dcolor, nothing)

        # Test that the function doesn't allocate
        fill!(dcolor, false)
        allocs = @allocated construct_augmenting_path!(matching, g, 1, _always_true, dcolor, nothing)
        @test allocs == 0
    end

    @testset "𝑠neighbors zero allocations" begin
        g = BipartiteGraph(10, 10)
        Graphs.add_edge!(g, 1, 1)
        Graphs.add_edge!(g, 1, 2)

        # Warm up
        𝑠neighbors(g, 1)

        # Test that 𝑠neighbors doesn't allocate
        allocs = @allocated 𝑠neighbors(g, 1)
        @test allocs == 0
    end

    @testset "𝑑neighbors zero allocations" begin
        g = BipartiteGraph(10, 10)
        Graphs.add_edge!(g, 1, 1)
        Graphs.add_edge!(g, 2, 1)

        # Warm up
        𝑑neighbors(g, 1)

        # Test that 𝑑neighbors doesn't allocate
        allocs = @allocated 𝑑neighbors(g, 1)
        @test allocs == 0
    end
end

"""
    @enum VertType SRC DST

An enum for selecting the source or destination side of a [`BipartiteGraph`](@ref).
See [`SRC`](@ref) and [`DST`](@ref).
"""
@enum VertType SRC DST

"""
    SRC

The source-side [`VertType`](@ref) selector for a [`BipartiteGraph`](@ref).

Use `SRC` as the `VertType` argument to methods that operate on one side of the graph,
such as `Graphs.add_vertex!(g, SRC)` to add a source vertex.
"""
SRC

"""
    DST

The destination-side [`VertType`](@ref) selector for a [`BipartiteGraph`](@ref).

Use `DST` as the `VertType` argument to methods that operate on one side of the graph,
such as `Graphs.add_vertex!(g, DST)` to add a destination vertex.
"""
DST

"""
    $TYPEDEF

The edge of a [`BipartiteGraph`](@ref). Use `Graphs.src` and `Graphs.dst` to get the source
and destination vertices.
"""
struct BipartiteEdge{I <: Integer} <: Graphs.AbstractEdge{I}
    src::I
    """
    The index of the destination vertex
    """
    dst::I
    function BipartiteEdge(src::I, dst::V) where {I, V}
        T = promote_type(I, V)
        return new{T}(T(src), T(dst))
    end
end

"""
    $TYPEDSIGNATURES

Obtain the source vertex of a [`BipartiteEdge`](@ref).
"""
Graphs.src(edge::BipartiteEdge) = edge.src

"""
    $TYPEDSIGNATURES

Obtain the destination vertex of a [`BipartiteEdge`](@ref).
"""
Graphs.dst(edge::BipartiteEdge) = edge.dst

function Base.show(io::IO, edge::BipartiteEdge)
    (; src, dst) = edge
    return print(io, "[src: ", src, "] => [dst: ", dst, "]")
end

Base.:(==)(a::BipartiteEdge, b::BipartiteEdge) = src(a) == src(b) && dst(a) == dst(b)

"""
$(TYPEDEF)

A bipartite graph representation between two, possibly distinct, sets of vertices
(source and dependencies). Maps source vertices, labelled `1:N₁`, to vertices
on which they depend (labelled `1:N₂`).

# Fields
$(FIELDS)

# Example
```julia
using BipartiteGraphs

# six source vertices
fadjlist = [[1],[1],[2],[2],[1],[1,2]]

# two vertices they depend on
badjlist = [[1,2,5,6],[3,4,6]]

bg = BipartiteGraph(7, fadjlist, badjlist)
```
"""
mutable struct BipartiteGraph{I <: Integer, M} <: Graphs.AbstractGraph{I}
    ne::Int
    fadjlist::Vector{Vector{I}} # `fadjlist[src] => dsts`
    badjlist::Union{Vector{Vector{I}}, I} # `badjlist[dst] => srcs` or `ndsts`
    metadata::M
end

"""
    $TYPEDSIGNATURES

Construct a bipartite graph with `ne` edges, given the forward and backward
adjacency lists. Instead of the backward adjacency list, an integer may be given
indicating the number of destination vertices. If this is not provided, the number
of destination vertices is inferred from the forward adjacency list. If the backward
adjacency list is not provided, it will not be stored and instead backward adjacency
will be computed lazily. Use [`complete`](@ref) to compute and store
the backward adjacency post-facto. A completed graph offers faster backward adjacency
lookup at the cost of slower edge insertion.

`ne` may be omitted, in which case it is inferred from the forward adjacency list.
"""
function BipartiteGraph(
        ne::Integer, fadj::AbstractVector,
        badj::Union{AbstractVector, Integer} = maximum(maximum, fadj);
        metadata = nothing
    )
    return BipartiteGraph(ne, fadj, badj, metadata)
end

function BipartiteGraph(
        fadj::AbstractVector,
        badj::Union{AbstractVector, Integer} = maximum(maximum, fadj);
        metadata = nothing
    )
    return BipartiteGraph(mapreduce(length, +, fadj; init = 0), fadj, badj, metadata)
end

"""
    $TYPEDSIGNATURES

Utility function to throw an error if the graph `g` is not [`complete`](@ref).
"""
@noinline function require_complete(g::BipartiteGraph)
    return g.badjlist isa AbstractVector ||
        throw(ArgumentError("The graph has no back edges. Use `complete`."))
end

"""
    $TYPEDSIGNATURES

Return a `BipartiteGraph` with the source and destination vertices swapped. Note that the
returned graph aliases `g`. Requires that `g` is [`complete`](@ref).
"""
function invview(g::BipartiteGraph)
    require_complete(g)
    return BipartiteGraph(g.ne, g.badjlist, g.fadjlist)
end

"""
    $TYPEDSIGNATURES

Populate the backward adjacency list of `g`, if it is not already stored.
"""
function complete(g::BipartiteGraph{I}) where {I}
    isa(g.badjlist, AbstractVector) && return g
    badjlist = Vector{I}[Vector{I}() for _ in 1:(g.badjlist)]
    for (s, l) in enumerate(g.fadjlist)
        for d in l
            push!(badjlist[d], s)
        end
    end
    return BipartiteGraph(g.ne, g.fadjlist, badjlist)
end

"""
    $TYPEDSIGNATURES

Test whether two [`BipartiteGraph`](@ref)s are equal.
"""
function Base.isequal(bg1::BipartiteGraph{T}, bg2::BipartiteGraph{T}) where {T <: Integer}
    iseq = (bg1.ne == bg2.ne)
    iseq &= (bg1.fadjlist == bg2.fadjlist)
    iseq &= (bg1.badjlist == bg2.badjlist)
    return iseq
end

"""
    $(TYPEDSIGNATURES)

Build an empty [`BipartiteGraph`](@ref) with `nsrcs` sources and `ndsts` destinations.
By default, the constructed graph is [`complete`](@ref)d. To avoid this
and lazily compute backward adjacency, pass `Val(false)` as the third argument.
"""
function BipartiteGraph(
        nsrcs::T, ndsts::T, backedge::Val{B} = Val(true);
        metadata = nothing
    ) where {T, B}
    fadjlist = map(_ -> T[], 1:nsrcs)
    badjlist = B ? map(_ -> T[], 1:ndsts) : ndsts
    return BipartiteGraph(0, fadjlist, badjlist, metadata)
end

function Base.copy(bg::BipartiteGraph)
    return BipartiteGraph(
        bg.ne, map(copy, bg.fadjlist), map(copy, bg.badjlist),
        deepcopy(bg.metadata)
    )
end
Base.eltype(::Type{<:BipartiteGraph{I}}) where {I} = I

"""
    $TYPEDSIGNATURES

Remove all edges from the graph, retaining the source and destination vertices.
"""
function Base.empty!(g::BipartiteGraph)
    foreach(empty!, g.fadjlist)
    g.badjlist isa AbstractVector && foreach(empty!, g.badjlist)
    g.ne = 0
    if g.metadata !== nothing
        foreach(empty!, g.metadata)
    end
    return g
end
Base.length(::BipartiteGraph) = error("length is not well defined! Use `ne` or `nv`.")

if isdefined(Graphs, :has_contiguous_vertices)
    Graphs.has_contiguous_vertices(::Type{<:BipartiteGraph}) = false
end
Graphs.is_directed(::Type{<:BipartiteGraph}) = false

"""
    $TYPEDSIGNATURES

Obtain both source and destination vertices of the graph as a tuple.
"""
Graphs.vertices(g::BipartiteGraph) = (𝑠vertices(g), 𝑑vertices(g))
"""
    $TYPEDSIGNATURES

Obtain the number of source vertices in the graph.
"""
𝑠vertices(g::BipartiteGraph) = axes(g.fadjlist, 1)
"""
    $TYPEDSIGNATURES

Obtain the number of destination vertices in the graph.
"""
function 𝑑vertices(g::BipartiteGraph)
    return g.badjlist isa AbstractVector ? axes(g.badjlist, 1) : Base.OneTo(g.badjlist)
end
"""
    $TYPEDSIGNATURES

Check if `v` is a source vertex of `g`.
"""
has_𝑠vertex(g::BipartiteGraph, v::Integer) = v in 𝑠vertices(g)
"""
    $TYPEDSIGNATURES

Check if `v` is a destination vertex of `g`.
"""
has_𝑑vertex(g::BipartiteGraph, v::Integer) = v in 𝑑vertices(g)
"""
    $TYPEDSIGNATURES

Obtain the neighbors of source vertex `i` in graph `g`.
"""
function 𝑠neighbors(
        g::BipartiteGraph, i::Integer,
        with_metadata::Val{M} = Val(false)
    ) where {M}
    return M ? zip(g.fadjlist[i], g.metadata[i]) : g.fadjlist[i]
end
"""
    $TYPEDSIGNATURES

Obtain the neighbors of destination vertex `i` in graph `g`.
"""
function 𝑑neighbors(
        g::BipartiteGraph, j::Integer,
        with_metadata::Val{M} = Val(false)
    ) where {M}
    require_complete(g)
    backj = g.badjlist[j]::Vector{Int}
    return M ? zip(backj, (g.metadata[i][j] for i in backj)) : backj
end
Graphs.ne(g::BipartiteGraph) = g.ne

"""
    $TYPEDSIGNATURES

Get the total number of vertices (source and destination) in the graph.
"""
Graphs.nv(g::BipartiteGraph) = sum(length, vertices(g))
Graphs.edgetype(g::BipartiteGraph{I}) where {I} = BipartiteEdge{I}

"""
    $TYPEDSIGNATURES

Get the number of source vertices in the graph.
"""
nsrcs(g::BipartiteGraph) = length(𝑠vertices(g))

"""
    $TYPEDSIGNATURES

Get the number of destination vertices in the graph.
"""
ndsts(g::BipartiteGraph) = length(𝑑vertices(g))

function Graphs.has_edge(g::BipartiteGraph, edge::BipartiteEdge)
    (; src, dst) = edge
    (src in 𝑠vertices(g) && dst in 𝑑vertices(g)) || return false  # edge out of bounds
    return insorted(dst, 𝑠neighbors(g, src))
end
Base.in(edge::BipartiteEdge, g::BipartiteGraph) = Graphs.has_edge(g, edge)

struct NoMetadata end
const NO_METADATA = NoMetadata()

"""
    $TYPEDSIGNATURES

Add an edge from source `i` to destination `j` in graph `g`.
"""
function Graphs.add_edge!(g::BipartiteGraph, i::Integer, j::Integer, md = NO_METADATA)
    return add_edge!(g, BipartiteEdge(i, j), md)
end
"""
    $TYPEDSIGNATURES

Add `edge` to graph `g`.
"""
function Graphs.add_edge!(g::BipartiteGraph, edge::BipartiteEdge, md = NO_METADATA)
    (; fadjlist, badjlist) = g
    s, d = src(edge), dst(edge)
    (has_𝑠vertex(g, s) && has_𝑑vertex(g, d)) || error("edge ($edge) out of range.")
    @inbounds list = fadjlist[s]
    index = searchsortedfirst(list, d)
    @inbounds (index <= length(list) && list[index] == d) && return false  # edge already in graph
    insert!(list, index, d)
    if md !== NO_METADATA
        insert!(g.metadata[s], index, md)
    end

    g.ne += 1
    if badjlist isa AbstractVector
        @inbounds list = badjlist[d]
        index = searchsortedfirst(list, s)
        insert!(list, index, s)
    end
    return true  # edge successfully added
end

"""
    $TYPEDSIGNATURES

Remove the edge from source `i` to destination `j` in graph `g`.
"""
function Graphs.rem_edge!(g::BipartiteGraph, i::Integer, j::Integer)
    return Graphs.rem_edge!(g, BipartiteEdge(i, j))
end
"""
    $TYPEDSIGNATURES

Femove `edge` from graph `g`.
"""
function Graphs.rem_edge!(g::BipartiteGraph, edge::BipartiteEdge)
    (; fadjlist, badjlist) = g
    s, d = src(edge), dst(edge)
    (has_𝑠vertex(g, s) && has_𝑑vertex(g, d)) || error("edge ($edge) out of range.")
    @inbounds list = fadjlist[s]
    index = searchsortedfirst(list, d)
    @inbounds (index <= length(list) && list[index] == d) ||
        error("graph does not have edge $edge")
    deleteat!(list, index)
    g.ne -= 1
    if badjlist isa AbstractVector
        @inbounds list = badjlist[d]
        index = searchsortedfirst(list, s)
        deleteat!(list, index)
    end
    return true  # edge successfully deleted
end

"""
    $TYPEDSIGNATURES

Add a vertex of type `type` to graph `g`.
"""
function Graphs.add_vertex!(g::BipartiteGraph{T}, type::VertType) where {T}
    if type === DST
        if g.badjlist isa AbstractVector
            push!(g.badjlist, T[])
            return length(g.badjlist)
        else
            g.badjlist += 1
            return g.badjlist
        end
    elseif type === SRC
        push!(g.fadjlist, T[])
        return length(g.fadjlist)
    else
        error("type ($type) must be either `DST` or `SRC`")
    end
end

"""
    $TYPEDSIGNATURES

In graph `g`, set the neighbors of source vertex `i` to `new_neighbors`.
"""
function set_neighbors!(g::BipartiteGraph, i::Integer, new_neighbors)
    old_neighbors = g.fadjlist[i]
    old_nneighbors = length(old_neighbors)
    new_nneighbors = length(new_neighbors)
    g.ne += new_nneighbors - old_nneighbors
    if isa(g.badjlist, AbstractVector)
        for n in old_neighbors
            @inbounds list = g.badjlist[n]
            index = searchsortedfirst(list, i)
            if 1 <= index <= length(list) && list[index] == i
                deleteat!(list, index)
            end
        end
        for n in new_neighbors
            @inbounds list = g.badjlist[n]
            index = searchsortedfirst(list, i)
            if !(1 <= index <= length(list) && list[index] == i)
                insert!(list, index, i)
            end
        end
    end
    return if iszero(new_nneighbors) # this handles Tuple as well
        # Warning: Aliases old_neighbors
        empty!(g.fadjlist[i])
    else
        g.fadjlist[i] = unique!(sort(new_neighbors))
    end
end

"""
    $TYPEDSIGNATURES

In graph `g`, remove all edges incident on source vertices in `srcs`. If `rm_verts` is
`true`, also remove the vertices from the graph. Note that this will cause
renumbering of source vertices.
"""
function delete_srcs!(g::BipartiteGraph{I}, srcs; rm_verts = false) where {I}
    for s in srcs
        set_neighbors!(g, s, ())
    end
    if rm_verts
        old_to_new_idxs = collect(one(I):I(nsrcs(g)))
        for s in srcs
            old_to_new_idxs[s] = zero(I)
        end
        offset = zero(I)
        for i in eachindex(old_to_new_idxs)
            if iszero(old_to_new_idxs[i])
                offset += one(I)
                continue
            end
            old_to_new_idxs[i] -= offset
        end

        if g.badjlist isa AbstractVector
            for i in 1:ndsts(g)
                for j in eachindex(g.badjlist[i])
                    g.badjlist[i][j] = old_to_new_idxs[g.badjlist[i][j]]
                end
                filter!(!iszero, g.badjlist[i])
            end
        end
        deleteat!(g.fadjlist, srcs)
    end
    return g
end

"""
    $TYPEDSIGNATURES

In graph `g`, remove all edges incident on destination vertices in `srcs`. If `rm_verts` is
`true`, also remove the vertices from the graph. Note that this will cause
renumbering of destination vertices.
"""
function delete_dsts!(g::BipartiteGraph, srcs; rm_verts = false)
    return delete_srcs!(invview(g), srcs; rm_verts)
end

###
### Edges iteration
###

"""
    $TYPEDSIGNATURES

Iterate over all edges in the graph, ordered by source vertices.
"""
Graphs.edges(g::BipartiteGraph) = BipartiteEdgeIter(g, Val(SRC))

"""
    $TYPEDSIGNATURES

Iterate over all edges in the graph, ordered by source vertices.
"""
𝑠edges(g::BipartiteGraph) = BipartiteEdgeIter(g, Val(SRC))

"""
    $TYPEDSIGNATURES

Iterate over all edges in the graph, ordered by destination vertices.
"""
𝑑edges(g::BipartiteGraph) = BipartiteEdgeIter(g, Val(DST))

"""
An iterator for edges in a [`BipartiteGraph`](@ref). The iteration order depends on the
`type` parameter: `Val(SRC)` iterates by source vertices, `Val(DST)` iterates by destination vertices.
"""
struct BipartiteEdgeIter{T, G} <: Graphs.AbstractEdgeIter
    g::G
    type::Val{T}
end

Base.length(it::BipartiteEdgeIter) = ne(it.g)
Base.eltype(it::BipartiteEdgeIter) = edgetype(it.g)

function Base.iterate(
        it::BipartiteEdgeIter{SRC, <:BipartiteGraph{T}},
        state = (1, 1, SRC)
    ) where {T}
    (; g) = it
    neqs = nsrcs(g)
    neqs == 0 && return nothing
    eq, jvar = state

    while eq <= neqs
        eq′ = eq
        vars = 𝑠neighbors(g, eq′)
        if jvar > length(vars)
            eq += 1
            jvar = 1
            continue
        end
        edge = BipartiteEdge(eq′, vars[jvar])
        state = (eq, jvar + 1, SRC)
        return edge, state
    end
    return nothing
end

function Base.iterate(
        it::BipartiteEdgeIter{DST, <:BipartiteGraph{T}},
        state = (1, 1, DST)
    ) where {T}
    (; g) = it
    nvars = ndsts(g)
    nvars == 0 && return nothing
    ieq, jvar = state

    while jvar <= nvars
        eqs = 𝑑neighbors(g, jvar)
        if ieq > length(eqs)
            ieq = 1
            jvar += 1
            continue
        end
        edge = BipartiteEdge(eqs[ieq], jvar)
        state = (ieq + 1, jvar, DST)
        return edge, state
    end
    return nothing
end

# Matrix whose only purpose is to pretty-print the bipartite graph

"""
A wrapper for adjacency lists used in pretty-printing bipartite graphs. Stores the
adjacency list along with optional highlighting information and matching status.
"""
struct BipartiteAdjacencyList
    u::Union{Vector{Int}, Nothing}
    highlight_u::Union{Set{Int}, Nothing}
    match::Any # Int or something else
end

"""
    $TYPEDSIGNATURES

Construct a [`BipartiteAdjacencyList`](@ref) without highlighting.
"""
function BipartiteAdjacencyList(u::Union{Vector{Int}, Nothing})
    return BipartiteAdjacencyList(u, nothing, unassigned)
end

"""
    overview_label(::Type{T}) where {T}
    overview_label(x) = overview_label(typeof(x))

Used for pretty-printing in `BipartiteAdjacencyList`. Given the type of
`BipartiteAdjacencyList.match`, returns a 3-tuple where the first element is
the symbol to print, the second element is a string describing what it means,
and the last element is the color to print it in.
"""
function overview_label end
overview_label(::Type) = error("No label defined for this matching type")
overview_label(x) = overview_label(typeof(x))

"""
A highlighted integer for pretty-printing, with color and matching status information.
"""
struct HighlightInt
    i::Int
    highlight::Symbol
    match::Bool
end
function Base.show(io::IO, hi::HighlightInt)
    return if hi.match
        printstyled(io, "(", color = hi.highlight)
        printstyled(io, hi.i, color = hi.highlight)
        printstyled(io, ")", color = hi.highlight)
    else
        printstyled(io, hi.i, color = hi.highlight)
    end
end

function Base.show(io::IO, l::BipartiteAdjacencyList)
    if !isa(l.match, Union{Int, Unassigned})
        (label, _, color) = overview_label(l.match)
        printstyled(io, string(label, " "); color)
    else
        printstyled(io, "  ")
    end
    return if l.u === nothing
        printstyled(io, '⋅', color = :light_black)
    elseif isempty(l.u)
        printstyled(io, '∅', color = :light_black)
    elseif l.highlight_u === nothing
        print(io, l.u)
    else
        match = l.match
        !isa(match, Int) && (match = unassigned)
        function choose_color(i)
            solvable = i in l.highlight_u
            matched = i == match
            return if !matched && solvable
                :default
            elseif !matched && !solvable
                :light_black
            elseif matched && solvable
                :light_yellow
            elseif matched && !solvable
                :magenta
            end
        end
        if !isempty(setdiff(l.highlight_u, l.u))
            # Only for debugging, shouldn't happen in practice
            print(
                io,
                map(union(l.u, l.highlight_u)) do i
                    HighlightInt(
                        i, !(i in l.u) ? :light_red : choose_color(i),
                        i == match
                    )
                end
            )
        else
            print(
                io, map(l.u) do i
                    HighlightInt(i, choose_color(i), i == match)
                end
            )
        end
    end
end

"""
A labeled string with an associated color for pretty-printing.
"""
struct Label
    s::String
    c::Symbol
end

"""
    $TYPEDSIGNATURES

Construct a label from a string without color.
"""
Label(s::AbstractString) = Label(s, :nothing)

"""
    $TYPEDSIGNATURES

Construct a label from an integer.
"""
Label(x::Integer) = Label(string(x))
Base.show(io::IO, l::Label) = printstyled(io, l.s, color = l.c)

"""
A matrix view of a [`BipartiteGraph`](@ref) for pretty-printing. Provides a tabular
representation with source and destination adjacency information.
"""
struct BipartiteGraphPrintMatrix <:
    AbstractMatrix{Union{Label, Int, BipartiteAdjacencyList}}
    bpg::BipartiteGraph
end
Base.size(bgpm::BipartiteGraphPrintMatrix) = (max(nsrcs(bgpm.bpg), ndsts(bgpm.bpg)) + 1, 3)
function Base.getindex(bgpm::BipartiteGraphPrintMatrix, i::Integer, j::Integer)
    checkbounds(bgpm, i, j)
    if i == 1
        return (Label.(("#", "src", "dst")))[j]
    elseif j == 1
        return i - 1
    elseif j == 2
        return BipartiteAdjacencyList(
            i - 1 <= nsrcs(bgpm.bpg) ?
                𝑠neighbors(bgpm.bpg, i - 1) : nothing
        )
    elseif j == 3
        return BipartiteAdjacencyList(
            i - 1 <= ndsts(bgpm.bpg) ?
                𝑑neighbors(bgpm.bpg, i - 1) : nothing
        )
    else
        @assert false
    end
end

function Base.show(io::IO, b::BipartiteGraph)
    print(
        io, "BipartiteGraph with (", length(b.fadjlist), ", ",
        isa(b.badjlist, Int) ? b.badjlist : length(b.badjlist), ") (𝑠,𝑑)-vertices\n"
    )
    return Base.show(io, MIME"text/plain"(), BipartiteGraphPrintMatrix(b))
end

"""
    $TYPEDSIGNATURES

For a hypergraph with vertex type `V`, print to `io` a hint/label for the given edge
`edge_i`. No hint is printed by default.
"""
function print_hyperedge_hint(io::IO, ::Type{V}, graph::HyperGraph{V}, edge_i::Int) where {V} end

function Base.show(io::IO, graph::HyperGraph{V}) where {V}
    printstyled(io, get(io, :cgraph_name, "HyperGraph"); color = :blue, bold = true)
    println(
        io, " with ", length(graph.labels),
        " vertices and ", nsrcs(graph.graph), " hyperedges"
    )
    compact = get(io, :compact, false)
    for edge_i in 𝑠vertices(graph.graph)
        if compact && edge_i > 5
            println(io, "⋮")
            break
        end
        print(io, "  ")
        print_hyperedge_hint(io, V, graph, edge_i)
        edge_idxs = 𝑠neighbors(graph.graph, edge_i)
        print(io, "<")
        for vi in @view(edge_idxs[1:(end - 1)])
            print(io, graph.invmap[vi], ", ")
        end
        println(io, graph.invmap[edge_idxs[end]], ">")
    end
    return
end

"""
    construct_augmenting_path!(m::Matching, g::BipartiteGraph, vsrc, dstfilter, vcolor = falses(ndsts(g)), ecolor = nothing) -> path_found::Bool

Try to construct an augmenting path in matching and if such a path is found,
update the matching accordingly.
"""
function construct_augmenting_path!(
        matching::Matching, g::BipartiteGraph, vsrc::Int, dstfilter,
        dcolor = falses(ndsts(g)), scolor = nothing
    )
    scolor === nothing || (scolor[vsrc] = true)

    # if a `vdst` is unassigned and the edge `vsrc <=> vdst` exists
    for vdst in 𝑠neighbors(g, vsrc)
        if dstfilter(vdst) && matching[vdst] === unassigned
            matching[vdst] = vsrc
            return true
        end
    end

    # for every `vsrc` such that edge `vsrc <=> vdst` exists and `vdst` is uncolored
    for vdst in 𝑠neighbors(g, vsrc)
        (dstfilter(vdst) && !dcolor[vdst]) || continue
        dcolor[vdst] = true
        # Check if the matched source is an Int before recursing to ensure type stability
        matched_src = matching[vdst]
        if matched_src isa Int && construct_augmenting_path!(
                matching, g, matched_src, dstfilter, dcolor,
                scolor
            )
            matching[vdst] = vsrc
            return true
        end
    end
    return false
end

# Default filter that always returns true - defined as a type for specialization
struct AlwaysTrue <: Function end
(::AlwaysTrue)(x) = true
const _always_true = AlwaysTrue()

"""
    maximal_matching(g::BipartiteGraph, [srcfilter], [dstfilter])

For a bipartite graph `g`, construct a maximal matching of destination to source
vertices, subject to the constraint that vertices for which `srcfilter` or `dstfilter`,
return `false` may not be matched.
"""
function maximal_matching(
        g::BipartiteGraph, ::Type{U} = Unassigned; srcfilter = _always_true,
        dstfilter = _always_true
    ) where {U}
    matching = Matching{U}(max(nsrcs(g), ndsts(g)))
    # Pre-allocate dcolor buffer to avoid allocations in construct_augmenting_path!
    dcolor = falses(ndsts(g))
    for vsrc in (v for v in 𝑠vertices(g) if srcfilter(v))
        # Reset dcolor for each source vertex
        fill!(dcolor, false)
        construct_augmenting_path!(matching, g, vsrc, dstfilter, dcolor, nothing)
    end
    return matching
end

using BipartiteGraphs
using Graphs
using Test

@testset "HyperGraph Construction" begin
    # Test empty construction
    hg = HyperGraph{String}()
    @test Graphs.nv(hg) == 0
    @test Graphs.ne(hg) == 0
    @test eltype(typeof(hg)) == String
end

@testset "Adding vertices and edges" begin
    hg = HyperGraph{Symbol}()

    # Add vertices
    @test Graphs.add_vertex!(hg, :a) == 1
    @test Graphs.add_vertex!(hg, :b) == 2
    @test Graphs.add_vertex!(hg, :c) == 3

    @test Graphs.nv(hg) == 3
    @test Graphs.ne(hg) == 0

    # Add duplicate vertex (should be no-op)
    @test Graphs.add_vertex!(hg, :a) == 1
    @test Graphs.nv(hg) == 3

    # Add hyperedges
    e1 = Graphs.add_edge!(hg, [:a, :b])
    @test e1 == 1
    @test Graphs.ne(hg) == 1

    e2 = Graphs.add_edge!(hg, [:b, :c])
    @test e2 == 2
    @test Graphs.ne(hg) == 2

    # Add hyperedge with new vertex
    e3 = Graphs.add_edge!(hg, [:a, :c, :d])
    @test e3 == 3
    @test Graphs.nv(hg) == 4  # :d was added
    @test Graphs.ne(hg) == 3
end

@testset "Vertex queries" begin
    hg = HyperGraph{Int}()
    Graphs.add_edge!(hg, [1, 2, 3])
    Graphs.add_edge!(hg, [2, 3, 4])

    # Test vertices
    @test Graphs.vertices(hg) == [1, 2, 3, 4]
    @test Graphs.nv(hg) == 4

    # Test has_vertex
    @test Graphs.has_vertex(hg, 1) == true
    @test Graphs.has_vertex(hg, 2) == true
    @test Graphs.has_vertex(hg, 3) == true
    @test Graphs.has_vertex(hg, 4) == true
    @test Graphs.has_vertex(hg, 5) == false
    @test Graphs.has_vertex(hg, 0) == false
end

@testset "Edge queries" begin
    hg = HyperGraph{String}()
    Graphs.add_edge!(hg, ["a", "b", "c"])
    Graphs.add_edge!(hg, ["b", "c", "d"])
    Graphs.add_edge!(hg, ["a", "d"])

    # Test ne
    @test Graphs.ne(hg) == 3

    # Test edgetype
    @test Graphs.edgetype(hg) == BipartiteGraphs.HyperEdge{String}

    # Test has_edge with vector
    @test Graphs.has_edge(hg, ["a", "b", "c"]) == true
    @test Graphs.has_edge(hg, ["b", "c", "d"]) == true
    @test Graphs.has_edge(hg, ["a", "d"]) == true
    @test Graphs.has_edge(hg, ["a", "b"]) == false
    @test Graphs.has_edge(hg, ["a", "b", "c", "d"]) == false

    # Test has_edge with tuple
    @test Graphs.has_edge(hg, ("a", "b", "c")) == true
    @test Graphs.has_edge(hg, ("a", "b")) == false

    # Test has_edge with set
    @test Graphs.has_edge(hg, Set(["a", "b", "c"])) == true
    @test Graphs.has_edge(hg, Set(["a", "b"])) == false

    # Test has_edge with non-existent vertices
    @test Graphs.has_edge(hg, ["x", "y", "z"]) == false
end

@testset "Edge iteration" begin
    hg = HyperGraph{Symbol}()
    e1 = Graphs.add_edge!(hg, [:a, :b, :c])
    e2 = Graphs.add_edge!(hg, [:b, :c, :d])
    e3 = Graphs.add_edge!(hg, [:a, :d])

    edges = collect(Graphs.edges(hg))
    @test length(edges) == 3
    @test edges[1].id == 1
    @test Set(edges[1].vertices) == Set([:a, :b, :c])
    @test edges[2].id == 2
    @test Set(edges[2].vertices) == Set([:b, :c, :d])
    @test edges[3].id == 3
    @test Set(edges[3].vertices) == Set([:a, :d])

    # Test iterator protocol
    edge_iter = Graphs.edges(hg)
    @test length(edge_iter) == 3
    @test eltype(edge_iter) == BipartiteGraphs.HyperEdge{Symbol}
end

@testset "Edge removal" begin
    hg = HyperGraph{Int}()
    Graphs.add_edge!(hg, [1, 2, 3])
    Graphs.add_edge!(hg, [2, 3, 4])
    Graphs.add_edge!(hg, [1, 4])

    @test Graphs.ne(hg) == 3

    # Remove an edge by vertices
    @test Graphs.rem_edge!(hg, [2, 3, 4]) == true
    @test Graphs.ne(hg) == 2
    @test Graphs.has_edge(hg, [2, 3, 4]) == false
    @test Graphs.has_edge(hg, [1, 2, 3]) == true
    @test Graphs.has_edge(hg, [1, 4]) == true

    # Try to remove non-existent edge
    @test Graphs.rem_edge!(hg, [2, 3, 4]) == false
    @test Graphs.rem_edge!(hg, [5, 6]) == false

    # Remove edge by HyperEdge object
    edges = collect(Graphs.edges(hg))
    edge_to_remove = edges[1]
    @test Graphs.rem_edge!(hg, edge_to_remove) == true
    @test Graphs.ne(hg) == 1

    # Verify remaining edge
    remaining_edges = collect(Graphs.edges(hg))
    @test length(remaining_edges) == 1
    @test Set(remaining_edges[1].vertices) == Set([1, 4])
end

@testset "Graph properties" begin
    hg = HyperGraph{Float64}()

    # Test is_directed
    @test Graphs.is_directed(hg) == false
    @test Graphs.is_directed(typeof(hg)) == false

    # Test has_contiguous_vertices (if defined in Graphs)
    if isdefined(Graphs, :has_contiguous_vertices)
        @test Graphs.has_contiguous_vertices(typeof(hg)) == false
    end

    # Test length error
    @test_throws ErrorException length(hg)
end

@testset "Neighbors and incident edges" begin
    hg = HyperGraph{String}()
    Graphs.add_edge!(hg, ["a", "b", "c"])
    Graphs.add_edge!(hg, ["b", "c", "d"])
    Graphs.add_edge!(hg, ["a", "d", "e"])

    # Test neighbors by edge ID
    @test Set(BipartiteGraphs.neighbors(hg, 1)) == Set(["a", "b", "c"])
    @test Set(BipartiteGraphs.neighbors(hg, 2)) == Set(["b", "c", "d"])
    @test Set(BipartiteGraphs.neighbors(hg, 3)) == Set(["a", "d", "e"])

    # Test neighbors by HyperEdge
    edges = collect(Graphs.edges(hg))
    @test Set(BipartiteGraphs.neighbors(hg, edges[1])) == Set(["a", "b", "c"])

    # Test neighbors with invalid ID
    @test_throws BoundsError BipartiteGraphs.neighbors(hg, 10)

    # Test incident_edges
    incident_b = BipartiteGraphs.incident_edges(hg, "b")
    @test length(incident_b) == 2
    incident_b_sets = [Set(e.vertices) for e in incident_b]
    @test Set(["a", "b", "c"]) in incident_b_sets
    @test Set(["b", "c", "d"]) in incident_b_sets

    incident_a = BipartiteGraphs.incident_edges(hg, "a")
    @test length(incident_a) == 2
    incident_a_sets = [Set(e.vertices) for e in incident_a]
    @test Set(["a", "b", "c"]) in incident_a_sets
    @test Set(["a", "d", "e"]) in incident_a_sets

    incident_e = BipartiteGraphs.incident_edges(hg, "e")
    @test length(incident_e) == 1
    @test Set(incident_e[1].vertices) == Set(["a", "d", "e"])

    # Test incident_edges with non-existent vertex
    @test_throws ArgumentError BipartiteGraphs.incident_edges(hg, "z")
end

@testset "Empty graph" begin
    hg = HyperGraph{Symbol}()
    Graphs.add_edge!(hg, [:a, :b, :c])
    Graphs.add_edge!(hg, [:d, :e])

    @test Graphs.nv(hg) == 5
    @test Graphs.ne(hg) == 2

    # Empty the graph
    empty!(hg)

    @test Graphs.nv(hg) == 0
    @test Graphs.ne(hg) == 0
    @test length(Graphs.vertices(hg)) == 0
    @test length(collect(Graphs.edges(hg))) == 0

    # Can add to empty graph again
    Graphs.add_edge!(hg, [:x, :y])
    @test Graphs.nv(hg) == 2
    @test Graphs.ne(hg) == 1
end

@testset "HyperEdge equality and display" begin
    # Test HyperEdge equality
    e1 = BipartiteGraphs.HyperEdge(1, [1, 2, 3])
    e2 = BipartiteGraphs.HyperEdge(1, [1, 2, 3])
    e3 = BipartiteGraphs.HyperEdge(2, [1, 2, 3])
    e4 = BipartiteGraphs.HyperEdge(1, [1, 2, 4])

    @test e1 == e2
    @test e1 != e3  # different id
    @test e1 != e4  # different vertices

    # Test display (just ensure it doesn't error)
    io = IOBuffer()
    show(io, e1)
    str = String(take!(io))
    @test occursin("HyperEdge", str)
    @test occursin("1", str)
end

@testset "Edge iteration after removal" begin
    hg = HyperGraph{Int}()
    Graphs.add_edge!(hg, [1, 2])
    Graphs.add_edge!(hg, [3, 4])
    Graphs.add_edge!(hg, [5, 6])

    # Remove middle edge
    Graphs.rem_edge!(hg, [3, 4])

    # Iteration should skip empty edge
    edges = collect(Graphs.edges(hg))
    @test length(edges) == 2
    @test Graphs.ne(hg) == 2

    # Verify the remaining edges are correct
    edge_sets = [Set(e.vertices) for e in edges]
    @test Set([1, 2]) in edge_sets
    @test Set([5, 6]) in edge_sets
    @test !(Set([3, 4]) in edge_sets)
end

@testset "Different vertex types" begin
    # Test with strings
    hg_str = HyperGraph{String}()
    Graphs.add_edge!(hg_str, ["alice", "bob", "charlie"])
    @test Graphs.nv(hg_str) == 3
    @test Graphs.ne(hg_str) == 1

    # Test with symbols
    hg_sym = HyperGraph{Symbol}()
    Graphs.add_edge!(hg_sym, [:x, :y, :z])
    @test Graphs.nv(hg_sym) == 3
    @test Graphs.ne(hg_sym) == 1

    # Test with integers
    hg_int = HyperGraph{Int}()
    Graphs.add_edge!(hg_int, [10, 20, 30])
    @test Graphs.nv(hg_int) == 3
    @test Graphs.ne(hg_int) == 1

    # Test with tuples (as vertex type)
    hg_tuple = HyperGraph{Tuple{Int, Int}}()
    Graphs.add_edge!(hg_tuple, [(1, 1), (2, 2), (3, 3)])
    @test Graphs.nv(hg_tuple) == 3
    @test Graphs.ne(hg_tuple) == 1
end

@testset "Single vertex hyperedges" begin
    hg = HyperGraph{Int}()

    # Add hyperedge with single vertex
    e1 = Graphs.add_edge!(hg, [1])
    @test Graphs.ne(hg) == 1
    @test Graphs.nv(hg) == 1

    # Check edge exists
    @test Graphs.has_edge(hg, [1]) == true

    # Get neighbors
    @test BipartiteGraphs.neighbors(hg, 1) == [1]

    # Remove single vertex hyperedge
    @test Graphs.rem_edge!(hg, [1]) == true
    @test Graphs.ne(hg) == 0
end

@testset "Large hyperedges" begin
    hg = HyperGraph{Int}()

    # Create a large hyperedge
    vertices = collect(1:100)
    e1 = Graphs.add_edge!(hg, vertices)

    @test Graphs.nv(hg) == 100
    @test Graphs.ne(hg) == 1
    @test Graphs.has_edge(hg, vertices) == true
    @test length(BipartiteGraphs.neighbors(hg, 1)) == 100

    # All vertices should be incident to this edge
    for v in vertices
        incident = BipartiteGraphs.incident_edges(hg, v)
        @test length(incident) == 1
        @test incident[1].id == e1
    end
end

@testset "Empty hyperedge handling" begin
    hg = HyperGraph{Int}()

    # Add edges
    Graphs.add_edge!(hg, [1, 2])
    Graphs.add_edge!(hg, [3, 4])

    # Remove first edge
    Graphs.rem_edge!(hg, [1, 2])

    # Add new edge (should get ID 3, not reuse ID 1)
    e3 = Graphs.add_edge!(hg, [5, 6])
    @test e3 == 3

    # Verify edge count is correct
    @test Graphs.ne(hg) == 2

    # Verify iteration skips empty edge at ID 1
    edges = collect(Graphs.edges(hg))
    edge_ids = [e.id for e in edges]
    @test 1 ∉ edge_ids
    @test 2 in edge_ids
    @test 3 in edge_ids
end

@testset "Connected components" begin
    # Test 1: Single connected component
    hg1 = HyperGraph{String}()
    Graphs.add_edge!(hg1, ["a", "b", "c"])
    Graphs.add_edge!(hg1, ["c", "d"])
    Graphs.add_edge!(hg1, ["d", "e"])

    components1 = Graphs.connected_components(hg1)
    @test length(components1) == 1
    @test Set(components1[1]) == Set(["a", "b", "c", "d", "e"])

    # Test 2: Multiple disconnected components
    hg2 = HyperGraph{Int}()
    Graphs.add_edge!(hg2, [1, 2, 3])
    Graphs.add_edge!(hg2, [4, 5])
    Graphs.add_edge!(hg2, [6, 7, 8])

    components2 = Graphs.connected_components(hg2)
    @test length(components2) == 3

    # Convert to sets for comparison (order doesn't matter)
    comp_sets = [Set(c) for c in components2]
    @test Set([1, 2, 3]) in comp_sets
    @test Set([4, 5]) in comp_sets
    @test Set([6, 7, 8]) in comp_sets

    # Test 3: Components connected through a chain of hyperedges
    hg3 = HyperGraph{Symbol}()
    Graphs.add_edge!(hg3, [:a, :b])
    Graphs.add_edge!(hg3, [:b, :c])
    Graphs.add_edge!(hg3, [:c, :d])
    Graphs.add_edge!(hg3, [:x, :y])  # separate component

    components3 = Graphs.connected_components(hg3)
    @test length(components3) == 2

    comp_sets3 = [Set(c) for c in components3]
    @test Set([:a, :b, :c, :d]) in comp_sets3
    @test Set([:x, :y]) in comp_sets3

    # Test 4: Single vertex in a hyperedge
    hg4 = HyperGraph{String}()
    Graphs.add_edge!(hg4, ["a"])
    Graphs.add_edge!(hg4, ["b", "c"])

    components4 = Graphs.connected_components(hg4)
    @test length(components4) == 2

    comp_sets4 = [Set(c) for c in components4]
    @test Set(["a"]) in comp_sets4
    @test Set(["b", "c"]) in comp_sets4

    # Test 5: Empty graph
    hg5 = HyperGraph{Int}()
    components5 = Graphs.connected_components(hg5)
    @test length(components5) == 0
    @test components5 == []

    # Test 6: Components merge through a shared vertex
    hg6 = HyperGraph{Int}()
    Graphs.add_edge!(hg6, [1, 2])
    Graphs.add_edge!(hg6, [3, 4])
    Graphs.add_edge!(hg6, [2, 3])  # connects the two previous components
    Graphs.add_edge!(hg6, [5, 6])  # separate component

    components6 = Graphs.connected_components(hg6)
    @test length(components6) == 2

    comp_sets6 = [Set(c) for c in components6]
    @test Set([1, 2, 3, 4]) in comp_sets6
    @test Set([5, 6]) in comp_sets6

    # Test 7: Large hyperedge connecting multiple vertices
    hg7 = HyperGraph{String}()
    Graphs.add_edge!(hg7, ["a", "b", "c", "d", "e", "f"])
    Graphs.add_edge!(hg7, ["x", "y"])

    components7 = Graphs.connected_components(hg7)
    @test length(components7) == 2

    comp_sets7 = [Set(c) for c in components7]
    @test Set(["a", "b", "c", "d", "e", "f"]) in comp_sets7
    @test Set(["x", "y"]) in comp_sets7

    # Test 8: Graph with removed edges (empty hyperedges should be skipped)
    hg8 = HyperGraph{Symbol}()
    Graphs.add_edge!(hg8, [:a, :b])
    Graphs.add_edge!(hg8, [:c, :d])
    Graphs.add_edge!(hg8, [:e, :f])

    # Remove middle edge
    Graphs.rem_edge!(hg8, [:c, :d])

    components8 = Graphs.connected_components(hg8)
    @test length(components8) == 4  # a-b, c, d, e-f

    comp_sets8 = [Set(c) for c in components8]
    @test Set([:a, :b]) in comp_sets8
    @test Set([:c]) in comp_sets8
    @test Set([:d]) in comp_sets8
    @test Set([:e, :f]) in comp_sets8
end

module BipartiteGraphs

using DocStringExtensions: DocStringExtensions, FIELDS, TYPEDEF,
    TYPEDFIELDS, TYPEDSIGNATURES
using Graphs: Graphs, AbstractGraph, connected_components, dst, edges, edgetype,
    has_edge, has_vertex, inneighbors, ne, nv, outneighbors, src, vertices
using Graphs.SimpleGraphs: SimpleDiGraph, SimpleEdge, add_edge!, add_vertex!, rem_edge!
using DataStructures: DataStructures
# DataStructures renamed `IntDisjointSets` to `IntDisjointSet` in v0.19; alias both
# spellings to a single internal name so the explicit import is used on either version
# (and so the alias does not shadow the imported name, which would make ExplicitImports
# flag the import as stale).
@static if pkgversion(DataStructures) >= v"0.19"
    using DataStructures: IntDisjointSet as _IntDisjointSet
else
    using DataStructures: IntDisjointSets as _IntDisjointSet
end

export Matching, Unassigned, unassigned
include("matching.jl")

export BipartiteEdge, BipartiteGraph
export 𝑠vertices, 𝑑vertices, has_𝑠vertex, has_𝑑vertex, 𝑠neighbors, 𝑑neighbors,
    𝑠edges, 𝑑edges, nsrcs, ndsts, SRC, DST, set_neighbors!, invview,
    delete_srcs!, delete_dsts!, complete, require_complete
include("bipartite_graph.jl")

export maximal_matching, construct_augmenting_path!
include("maximal_matching.jl")

export DiCMOBiGraph
include("dicmobigraph.jl")

export InducedCondensationGraph, MatchedCondensationGraph
include("condensation_graphs.jl")

export HyperGraph, HyperEdge, HyperGraphEdge, neighbors, incident_edges
include("hypergraph.jl")

include("pretty_printing.jl")

include("deprecations.jl")

include("precompilation.jl")

end

using BipartiteGraphs
using Graphs
using Test

@testset "Construction" begin
    e = BipartiteEdge(1, 2)
    @test src(e) == 1
    @test dst(e) == 2

    # Test type promotion
    e2 = BipartiteEdge(Int32(1), Int64(2))
    @test src(e2) isa Int64
    @test dst(e2) isa Int64
end

@testset "Equality" begin
    e1 = BipartiteEdge(1, 2)
    e2 = BipartiteEdge(1, 2)
    e3 = BipartiteEdge(1, 3)

    @test e1 == e2
    @test e1 != e3
end

@testset "Construction from adjacency lists" begin
    # Simple bipartite graph
    fadjlist = [[1], [1], [2], [2], [1], [1, 2]]
    badjlist = [[1, 2, 5, 6], [3, 4, 6]]

    g = BipartiteGraph(7, fadjlist, badjlist)
    @test ne(g) == 7
    @test nsrcs(g) == 6
    @test ndsts(g) == 2

    # Test inferred ne
    g2 = BipartiteGraph(fadjlist, badjlist)
    @test ne(g2) == 7

    # Test without backward adjacency
    g3 = BipartiteGraph(fadjlist, 2)
    @test ndsts(g3) == 2
    @test g3.badjlist isa Int
end

@testset "Empty graph construction" begin
    g = BipartiteGraph(5, 3)
    @test nsrcs(g) == 5
    @test ndsts(g) == 3
    @test ne(g) == 0
    @test g.badjlist isa AbstractVector

    # Test without backedges
    g2 = BipartiteGraph(5, 3, Val(false))
    @test g2.badjlist isa Int
end

@testset "Graph queries" begin
    fadjlist = [[1, 2], [2], [1]]
    badjlist = [[1, 3], [1, 2]]
    g = BipartiteGraph(fadjlist, badjlist)

    @test 𝑠vertices(g) == 1:3
    @test 𝑑vertices(g) == 1:2
    @test vertices(g) == (1:3, 1:2)
    @test nv(g) == 5

    @test has_𝑠vertex(g, 1)
    @test has_𝑠vertex(g, 3)
    @test !has_𝑠vertex(g, 4)

    @test has_𝑑vertex(g, 1)
    @test has_𝑑vertex(g, 2)
    @test !has_𝑑vertex(g, 3)

    @test 𝑠neighbors(g, 1) == [1, 2]
    @test 𝑠neighbors(g, 2) == [2]
    @test 𝑠neighbors(g, 3) == [1]

    @test 𝑑neighbors(g, 1) == [1, 3]
    @test 𝑑neighbors(g, 2) == [1, 2]
end

@testset "Edge operations" begin
    g = BipartiteGraph(3, 2)

    # Add edges
    @test add_edge!(g, 1, 1)
    @test ne(g) == 1
    @test has_edge(g, BipartiteEdge(1, 1))

    @test add_edge!(g, 1, 2)
    @test ne(g) == 2

    # Adding existing edge should return false
    @test !add_edge!(g, 1, 1)
    @test ne(g) == 2

    # Test with BipartiteEdge
    @test add_edge!(g, BipartiteEdge(2, 1))
    @test ne(g) == 3

    # Remove edge
    @test rem_edge!(g, 1, 1)
    @test ne(g) == 2
    @test !has_edge(g, BipartiteEdge(1, 1))

    @test rem_edge!(g, BipartiteEdge(2, 1))
    @test ne(g) == 1
end

@testset "Vertex operations" begin
    g = BipartiteGraph(2, 2)

    # Add source vertex
    new_src = add_vertex!(g, SRC)
    @test new_src == 3
    @test nsrcs(g) == 3

    # Add destination vertex
    new_dst = add_vertex!(g, DST)
    @test new_dst == 3
    @test ndsts(g) == 3
end

@testset "set_neighbors!" begin
    g = BipartiteGraph(3, 3)
    add_edge!(g, 1, 1)
    add_edge!(g, 1, 2)

    # Change neighbors
    set_neighbors!(g, 1, [2, 3])
    @test 𝑠neighbors(g, 1) == [2, 3]
    @test !has_edge(g, BipartiteEdge(1, 1))
    @test has_edge(g, BipartiteEdge(1, 3))

    # Clear neighbors
    set_neighbors!(g, 1, ())
    @test isempty(𝑠neighbors(g, 1))
end

@testset "Edge iteration" begin
    fadjlist = [[1, 2], [2], [1]]
    g = BipartiteGraph(fadjlist, 2)

    edges_vec = collect(edges(g))
    @test length(edges_vec) == 4

    # Test source edge iteration
    sedges = collect(𝑠edges(g))
    @test length(sedges) == 4
    @test all(e -> e isa BipartiteEdge, sedges)

    # Test destination edge iteration (requires complete)
    g_complete = complete(g)
    dedges = collect(𝑑edges(g_complete))
    @test length(dedges) == 4
end

@testset "Graph completion" begin
    fadjlist = [[1, 2], [2], [1]]
    g = BipartiteGraph(fadjlist, 2)
    @test g.badjlist isa Int

    g_complete = complete(g)
    @test g_complete.badjlist isa AbstractVector
    @test length(g_complete.badjlist) == 2

    # Completing again should not change
    g_complete2 = complete(g_complete)
    @test g_complete2 === g_complete
end

@testset "invview" begin
    fadjlist = [[1, 2], [2], [1]]
    badjlist = [[1, 3], [1, 2]]
    g = BipartiteGraph(fadjlist, badjlist)

    g_inv = invview(g)
    @test nsrcs(g_inv) == 2
    @test ndsts(g_inv) == 3
    @test 𝑠neighbors(g_inv, 1) == [1, 3]
    @test 𝑠neighbors(g_inv, 2) == [1, 2]
end

@testset "copy and empty!" begin
    fadjlist = [[1, 2], [2]]
    badjlist = [[1], [1, 2]]
    g = BipartiteGraph(fadjlist, badjlist)

    # Test copy
    g_copy = copy(g)
    add_edge!(g_copy, 2, 1)
    @test ne(g_copy) == 4
    @test ne(g) == 3  # Original unchanged

    # Test empty!
    empty!(g_copy)
    @test ne(g_copy) == 0
    @test all(isempty, g_copy.fadjlist)
end

@testset "isequal" begin
    fadjlist = [[1], [2]]
    badjlist = [[1], [2]]
    g1 = BipartiteGraph(fadjlist, badjlist)
    g2 = BipartiteGraph(fadjlist, badjlist)

    @test isequal(g1, g2)

    add_edge!(g2, 1, 2)
    @test !isequal(g1, g2)
end

@testset "delete_srcs! and delete_dsts!" begin
    fadjlist = [[1], [1, 2], [2], [1, 2]]
    g = BipartiteGraph(fadjlist, 2)
    g = complete(g)
    initial_ne = ne(g)

    # Delete source vertices (remove edges only)
    delete_srcs!(g, [2])
    @test ne(g) <= initial_ne
    @test 𝑠neighbors(g, 2) == []

    # Delete with vertex removal
    g2 = BipartiteGraph([[1], [1, 2], [2], [1, 2]], 2)
    g2 = complete(g2)
    delete_srcs!(g2, [2]; rm_verts = true)
    @test nsrcs(g2) == 3

    # Delete destination vertices
    g3 = BipartiteGraph([[1], [1, 2], [2]], 2)
    g3 = complete(g3)
    delete_dsts!(g3, [1])
    @test 𝑠neighbors(g3, 1) == []
end

@testset "require_complete errors" begin
    g = BipartiteGraph([[1], [2]], 2)
    @test_throws ArgumentError require_complete(g)

    g_complete = complete(g)
    require_complete(g_complete)  # Should not throw
    @test true
end

@testset "Edge out of bounds" begin
    g = BipartiteGraph(2, 2)
    @test_throws Exception add_edge!(g, 3, 1)  # Source out of bounds
    @test_throws Exception add_edge!(g, 1, 3)  # Dest out of bounds
end

@testset "Remove non-existent edge" begin
    g = BipartiteGraph(2, 2)
    add_edge!(g, 1, 1)
    @test_throws Exception rem_edge!(g, 1, 2)  # Edge doesn't exist
end

@testset "Invalid vertex type" begin
    g = BipartiteGraph(2, 2)
    # This should error with invalid type
    @test_throws Exception add_vertex!(g, :INVALID)
end

@testset "BipartiteGraph length error" begin
    g = BipartiteGraph(2, 2)
    @test_throws ErrorException length(g)
end

@testset "Graph with metadata" begin
    fadjlist = [[1], [2]]
    g = BipartiteGraph(fadjlist, 2; metadata = [[1.0], [2.0]])
    @test g.metadata !== nothing

    # Test 𝑠neighbors with metadata
    neighs_with_meta = 𝑠neighbors(g, 1, Val(true))
    @test neighs_with_meta isa Base.Iterators.Zip

    # Test add_edge with metadata
    add_edge!(g, 1, 2, 1.5)
    @test ne(g) == 3

    # Test empty! with metadata
    empty!(g)
    @test ne(g) == 0
end

@testset "BipartiteGraph copy with metadata" begin
    fadjlist = [[1], [2]]
    g = BipartiteGraph(fadjlist, 2; metadata = [[1.0], [2.0]])
    g_copy = copy(g)
    @test g_copy.metadata !== nothing
    @test g_copy.metadata !== g.metadata  # Should be deep copied
end

@testset "eltype" begin
    g = BipartiteGraph(Int32(2), Int32(2))
    @test eltype(g) == Int32
end

"""
    struct DiCMOBiGraph

This data structure implements a "directed, contracted, matching-oriented" view of an
original (undirected) bipartite graph. It has two modes, depending on the `Transposed`
flag, which switches the direction of the induced matching.

Essentially the graph adapter performs two largely orthogonal functions
[`Transposed == true` differences are indicated in square brackets]:

 1. It pairs an undirected bipartite graph with a matching of the destination vertex.

    This matching is used to induce an orientation on the otherwise undirected graph:
    Matched edges pass from destination to source [source to destination], all other edges
    pass in the opposite direction.

 2. It exposes the graph view obtained by contracting the destination [source] vertices
    along the matched edges.

The result of this operation is an induced, directed graph on the source [destination] vertices.
The resulting graph has a few desirable properties. In particular, this graph
is acyclic if and only if the induced directed graph on the original bipartite
graph is acyclic.

# Hypergraph interpretation

Consider the bipartite graph `B` as the incidence graph of some hypergraph `H`.
Note that a matching `M` on `B` in the above sense is equivalent to determining
an (1,n)-orientation on the hypergraph (i.e. each directed hyperedge has exactly
one head, but any arbitrary number of tails). In this setting, this is simply
the graph formed by expanding each directed hyperedge into `n` ordinary edges
between the same vertices.
"""
mutable struct DiCMOBiGraph{Transposed, I, G <: BipartiteGraph{I}, M <: Matching} <:
    Graphs.AbstractGraph{I}
    graph::G
    ne::Union{Missing, Int}
    matching::M
    function DiCMOBiGraph{Transposed}(
            g::G, ne::Union{Missing, Int},
            m::M
        ) where {Transposed, I, G <: BipartiteGraph{I}, M}
        return new{Transposed, I, G, M}(g, ne, m)
    end
end

"""
    $TYPEDSIGNATURES

Construct a [`DiCMOBiGraph`](@ref) from a bipartite graph with an empty matching.
"""
function DiCMOBiGraph{Transposed}(g::BipartiteGraph) where {Transposed}
    return DiCMOBiGraph{Transposed}(g, 0, Matching(ndsts(g)))
end

"""
    $TYPEDSIGNATURES

Construct a [`DiCMOBiGraph`](@ref) from a bipartite graph and a matching.
"""
function DiCMOBiGraph{Transposed}(g::BipartiteGraph, m::M) where {Transposed, M}
    return DiCMOBiGraph{Transposed}(g, missing, m)
end

"""
    $TYPEDSIGNATURES

Return a [`DiCMOBiGraph`](@ref) with the source and destination vertices swapped. The
returned graph aliases `g`.
"""
function invview(g::DiCMOBiGraph{Transposed}) where {Transposed}
    return DiCMOBiGraph{!Transposed}(invview(g.graph), g.ne, invview(g.matching))
end

Graphs.is_directed(::Type{<:DiCMOBiGraph}) = true
function Graphs.nv(g::DiCMOBiGraph{Transposed}) where {Transposed}
    return Transposed ? ndsts(g.graph) : nsrcs(g.graph)
end
function Graphs.vertices(g::DiCMOBiGraph{Transposed}) where {Transposed}
    return Transposed ? 𝑑vertices(g.graph) : 𝑠vertices(g.graph)
end

"""
    $TYPEDEF

An iterator for neighbors in a [`DiCMOBiGraph`](@ref).
"""
struct CMONeighbors{Transposed, G <: DiCMOBiGraph{Transposed}, V}
    g::G
    """
    The vertex whose neighbors are being iterated over.
    """
    v::V
    function CMONeighbors{Transposed}(
            g::DiCMOBiGraph{Transposed},
            v::V
        ) where {Transposed, V}
        return new{Transposed, typeof(g), V}(g, v)
    end
end

Graphs.outneighbors(g::DiCMOBiGraph{false}, v) = CMONeighbors{false}(g, v)
Graphs.inneighbors(g::DiCMOBiGraph{false}, v) = inneighbors(invview(g), v)
Base.iterate(c::CMONeighbors{false}) = iterate(c, (c.g.graph.fadjlist[c.v],))
function Base.iterate(c::CMONeighbors{false}, (l, state...))
    while true
        r = iterate(l, state...)
        r === nothing && return nothing
        # If this is a matched edge, skip it, it's reversed in the induced
        # directed graph. Otherwise, if there is no matching for this destination
        # edge, also skip it, since it got deleted in the contraction.
        vsrc = c.g.matching[r[1]]
        if vsrc === c.v || !isa(vsrc, Int)
            state = (r[2],)
            continue
        end
        return vsrc, (l, r[2])
    end
    return
end
Base.length(c::CMONeighbors{false}) = count(_ -> true, c)

@inline _vsrc(c::CMONeighbors{true}) = c.g.matching[c.v]
function _neighbors(c::CMONeighbors{true})
    vsrc = _vsrc(c)
    if vsrc isa Int
        return c.g.graph.fadjlist[vsrc]
    else
        return nothing
    end
end
function Base.length(c::CMONeighbors{true})
    nbors = _neighbors(c)
    return length(@something(nbors, 1)) - 1
end

Graphs.inneighbors(g::DiCMOBiGraph{true}, v) = CMONeighbors{true}(g, v)
Graphs.outneighbors(g::DiCMOBiGraph{true}, v) = outneighbors(invview(g), v)
function Base.iterate(c::CMONeighbors{true})
    nbors = _neighbors(c)
    nbors === nothing && return nothing
    return iterate(c, (nbors,))
end
function Base.iterate(c::CMONeighbors{true}, (l, state...))
    while true
        r = iterate(l, state...)
        r === nothing && return nothing
        if r[1] === c.v
            state = (r[2],)
            continue
        end
        return r[1], (l, r[2])
    end
    return
end

function _edges(g::DiCMOBiGraph{Transposed}) where {Transposed}
    return Transposed ?
        ((w => v for w in inneighbors(g, v)) for v in vertices(g)) :
        ((v => w for w in outneighbors(g, v)) for v in vertices(g))
end

Graphs.edges(g::DiCMOBiGraph) = (SimpleEdge(p) for p in Iterators.flatten(_edges(g)))
function Graphs.ne(g::DiCMOBiGraph)
    if g.ne === missing
        g.ne = mapreduce(x -> length(x.iter), +, _edges(g))
    end
    return g.ne
end

Graphs.has_edge(g::DiCMOBiGraph{true}, a, b) = a in inneighbors(g, b)
Graphs.has_edge(g::DiCMOBiGraph{false}, a, b) = b in outneighbors(g, a)

# Required for `induced_subgraph` compatibility.
(::Type{<:DiCMOBiGraph})(n::Integer) = SimpleDiGraph(n)

using BipartiteGraphs
using Graphs
using Test

@testset "MatchedCondensationGraph construction" begin
    fadjlist = [[1, 2], [2, 3], [3]]
    g = BipartiteGraph(fadjlist, 3)
    m = Matching(3)
    m[1] = 1
    m[2] = 2
    m[3] = 3

    dmog = DiCMOBiGraph{false}(complete(g), m)

    # Create SCCs
    sccs = [[1], [2], [3]]
    mcg = MatchedCondensationGraph(dmog, sccs)

    @test nv(mcg) == 3
    @test is_directed(mcg)
    @test vertices(mcg) == 1:3
end

@testset "InducedCondensationGraph construction" begin
    fadjlist = [[1, 2], [2, 3], [3]]
    g = BipartiteGraph(fadjlist, 3)

    sccs = [[1], [2], [3]]
    icg = InducedCondensationGraph(complete(g), sccs)

    @test nv(icg) == 3
    @test is_directed(icg)
    @test vertices(icg) == 1:3
end

@testset "Condensation graph with non-trivial SCCs" begin
    fadjlist = [[1, 2], [2, 3], [3, 1]]
    g = BipartiteGraph(fadjlist, 3)

    # All vertices in one SCC (cycle)
    sccs = [[1, 2, 3]]
    icg = InducedCondensationGraph(complete(g), sccs)

    @test nv(icg) == 1

    # Mixed: one non-trivial SCC and one singleton
    sccs2 = [[1, 2], [3]]
    icg2 = InducedCondensationGraph(complete(g), sccs2)
    @test nv(icg2) == 2
end

@testset "Neighbors in condensation graphs" begin
    fadjlist = [[1], [2], [1, 2]]
    g = BipartiteGraph(fadjlist, 2)

    sccs = [[1], [2]]  # Each dest is its own SCC
    icg = InducedCondensationGraph(complete(g), sccs)

    # Check that we can iterate neighbors
    out_neighs_1 = collect(outneighbors(icg, 1))
    @test out_neighs_1 isa Vector

    in_neighs_2 = collect(inneighbors(icg, 2))
    @test in_neighs_2 isa Vector
end

@testset "MatchedCondensationGraph neighbors" begin
    fadjlist = [[1, 2], [2, 3], [1, 3]]
    g = BipartiteGraph(fadjlist, 3)
    m = Matching(3)
    m[1] = 1
    m[2] = 2
    m[3] = 3
    m = complete(m, 3)  # Complete the matching

    dmog = DiCMOBiGraph{false}(complete(g), m)
    sccs = [[1], [2], [3]]
    mcg = MatchedCondensationGraph(dmog, sccs)

    # Test outneighbors iterator type
    out_neighs_iter = outneighbors(mcg, 1)
    @test out_neighs_iter isa Base.Iterators.Flatten

    # Test inneighbors iterator type
    in_neighs_iter = inneighbors(mcg, 1)
    @test in_neighs_iter isa Base.Iterators.Flatten
end

@testset "InducedCondensationGraph with mixed SCCs" begin
    fadjlist = [[1], [1, 2], [2, 3], [3]]
    g = BipartiteGraph(fadjlist, 3)

    # Test with Union type (int inline)
    sccs = Union{Int, Vector{Int}}[1, [2, 3]]
    icg = InducedCondensationGraph(complete(g), sccs)
    @test nv(icg) == 2
end

"""
    $TYPEDEF

A hyperedge in a [`HyperGraph`](@ref), represented as a set of vertices.
"""
struct HyperEdge{V}
    """
    The integer ID of this hyperedge in the underlying bipartite graph.
    """
    id::Int
    """
    The set of vertices in this hyperedge.
    """
    vertices::Vector{V}
end

Base.:(==)(a::HyperEdge, b::HyperEdge) = a.id == b.id && a.vertices == b.vertices

function Base.show(io::IO, edge::HyperEdge)
    return print(io, "HyperEdge(", edge.id, ", ", edge.vertices, ")")
end

"""
    $(TYPEDEF)

A hypergraph represented using a [`BipartiteGraph`](@ref). Vertices of this graph are of
type `V`.

## Fields

$(TYPEDFIELDS)
"""
struct HyperGraph{V}
    """
    Mapping from vertices to their integer ID.
    """
    labels::Dict{V, Int}
    """
    Reverse mapping from integer ID to vertices.
    """
    invmap::Vector{V}
    """
    Core data structure for storing the hypergraph. Each hyperedge is a source vertex and
    has bipartite edges to the connection vertices it is incident on.
    """
    graph::BipartiteGraph{Int, Nothing}
end

"""
    $(TYPEDSIGNATURES)

Create an empty `ConnectionGraph`.
"""
function HyperGraph{V}() where {V}
    graph = BipartiteGraph(0, 0, Val(true))
    return HyperGraph{V}(Dict{V, Int}(), V[], graph)
end

"""
    $(TYPEDSIGNATURES)

Add the given vertex to the connection graph. Return the integer ID of the added vertex.
No-op if the vertex already exists.
"""
function Graphs.add_vertex!(graph::HyperGraph{V}, dst::V) where {V}
    j = get(graph.labels, dst, 0)
    iszero(j) || return j
    j = Graphs.add_vertex!(graph.graph, DST)
    push!(graph.invmap, dst)
    @assert length(graph.invmap) == j
    graph.labels[dst] = j
    return j
end

"""
    $TYPEDEF

Valid type to specify the edge of a `HyperGraph`.
"""
const HyperGraphEdge{V} = Union{Vector{V}, Tuple{Vararg{V}}, Set{V}}

"""
    $(TYPEDSIGNATURES)

Add the given hyperedge to the connection graph. Adds all vertices in the given edge if
they do not exist. Returns the integer ID of the added edge.
"""
function Graphs.add_edge!(graph::HyperGraph{V}, src::HyperGraphEdge{V}) where {V}
    i = Graphs.add_vertex!(graph.graph, SRC)
    for vert in src
        j = Graphs.add_vertex!(graph, vert)
        Graphs.add_edge!(graph.graph, i, j)
    end
    return i
end

Base.eltype(::Type{<:HyperGraph{V}}) where {V} = V

if isdefined(Graphs, :has_contiguous_vertices)
    Graphs.has_contiguous_vertices(::Type{<:HyperGraph}) = false
end

"""
    $TYPEDSIGNATURES

Hypergraphs are undirected.
"""
Graphs.is_directed(::Type{<:HyperGraph}) = false

"""
    $TYPEDSIGNATURES

Get all vertices in the hypergraph.
"""
Graphs.vertices(g::HyperGraph) = g.invmap

"""
    $TYPEDSIGNATURES

Get the number of vertices in the hypergraph.
"""
Graphs.nv(g::HyperGraph) = length(g.invmap)

"""
    $TYPEDSIGNATURES

Check if vertex `v` exists in the hypergraph.
"""
Graphs.has_vertex(g::HyperGraph{V}, v::V) where {V} = haskey(g.labels, v)

"""
    $TYPEDSIGNATURES

Get the number of hyperedges in the hypergraph. Only counts non-empty hyperedges.
"""
function Graphs.ne(g::HyperGraph)
    return count(i -> !isempty(𝑠neighbors(g.graph, i)), 𝑠vertices(g.graph))
end

Graphs.edgetype(::HyperGraph{V}) where {V} = HyperEdge{V}

"""
    $TYPEDSIGNATURES

Check if a hyperedge exists in the hypergraph. The edge can be specified as a `HyperEdge`
or as a collection of vertices.
"""
function Graphs.has_edge(g::HyperGraph{V}, edge::HyperEdge{V}) where {V}
    edge.id in 𝑠vertices(g.graph) || return false
    return Graphs.has_edge(g, edge.vertices)
end

function Graphs.has_edge(g::HyperGraph{V}, vertices::HyperGraphEdge{V}) where {V}
    return _edge_idx(g, vertices) !== nothing
end

function _edge_idx(g::HyperGraph{V}, vertices::HyperGraphEdge{V}) where {V}
    # Check if all vertices exist
    all(v -> haskey(g.labels, v), vertices) || return nothing
    # Convert to integer IDs
    vertex_ids = [g.labels[v] for v in vertices]
    sort!(vertex_ids)
    # Search through all hyperedges
    for i in 𝑠vertices(g.graph)
        neighbors = 𝑠neighbors(g.graph, i)
        if neighbors == vertex_ids
            return i
        end
    end
    return nothing
end

"""
    $TYPEDSIGNATURES

Remove a hyperedge from the hypergraph. The edge can be specified as a `HyperEdge` or as a
collection of vertices. Returns `true` if the edge was removed, `false` if it did not exist.
"""
function Graphs.rem_edge!(g::HyperGraph, edge::HyperEdge)
    edge.id in 𝑠vertices(g.graph) || return false
    # Remove all edges from this hyperedge to its vertices
    set_neighbors!(g.graph, edge.id, ())
    return true
end

function Graphs.rem_edge!(g::HyperGraph{V}, vertices::HyperGraphEdge{V}) where {V}
    # Find the hyperedge with these vertices
    idx = _edge_idx(g, vertices)
    if idx isa Int
        set_neighbors!(g.graph, idx, ())
        return true
    end
    return false
end

"""
    $TYPEDSIGNATURES

Iterate over all hyperedges in the hypergraph.
"""
Graphs.edges(g::HyperGraph{V}) where {V} = HyperEdgeIter(g)

"""
An iterator for hyperedges in a [`HyperGraph`](@ref).
"""
struct HyperEdgeIter{V, G <: HyperGraph{V}}
    g::G
end

Base.length(it::HyperEdgeIter) = Graphs.ne(it.g)
Base.eltype(it::HyperEdgeIter{V}) where {V} = HyperEdge{V}

function Base.iterate(it::HyperEdgeIter{V}, state = 1) where {V}
    (; g) = it
    nsrcs_val = nsrcs(g.graph)
    nsrcs_val == 0 && return nothing

    # Find the next non-empty hyperedge
    while state <= nsrcs_val
        neighbor_ids = 𝑠neighbors(g.graph, state)
        if !isempty(neighbor_ids)
            vertices = [g.invmap[j] for j in neighbor_ids]
            edge = HyperEdge(state, vertices)
            return edge, state + 1
        end
        state += 1
    end

    return nothing
end

"""
    $TYPEDSIGNATURES

Remove all hyperedges and vertices from the hypergraph.
"""
function Base.empty!(g::HyperGraph)
    empty!(g.labels)
    empty!(g.invmap)
    # Fully clear the underlying bipartite graph
    empty!(g.graph.fadjlist)
    if g.graph.badjlist isa AbstractVector
        empty!(g.graph.badjlist)
    else
        g.graph.badjlist = 0
    end
    g.graph.ne = 0
    return g
end

"""
    $TYPEDSIGNATURES

Get the vertices in a hyperedge (specified by its integer ID).
"""
function neighbors(g::HyperGraph, edge_id::Int)
    edge_id in 𝑠vertices(g.graph) || throw(BoundsError(g, edge_id))
    neighbor_ids = 𝑠neighbors(g.graph, edge_id)
    return [g.invmap[j] for j in neighbor_ids]
end

"""
    $TYPEDSIGNATURES

Get the vertices in a hyperedge.
"""
neighbors(g::HyperGraph, edge::HyperEdge) = edge.vertices

"""
    $TYPEDSIGNATURES

Get all hyperedges that contain vertex `v`.
"""
function incident_edges(g::HyperGraph{V}, v::V) where {V}
    haskey(g.labels, v) || throw(ArgumentError("Vertex $v not in graph"))
    v_id = g.labels[v]
    edge_ids = 𝑑neighbors(g.graph, v_id)
    return [HyperEdge(i, neighbors(g, i)) for i in edge_ids]
end

Base.length(::HyperGraph) = error("length is not well defined! Use `ne` or `nv`.")

"""
    $TYPEDSIGNATURES

Find the connected components of the given hypergraph.
"""
function Graphs.connected_components(graph::HyperGraph{V}) where {V}
    bigraph = graph.graph
    invmap = graph.invmap

    # union all of the hyperedges
    disjoint_sets = _IntDisjointSet(length(invmap))
    for edge_i in 𝑠vertices(bigraph)
        hyperedge = 𝑠neighbors(bigraph, edge_i)
        isempty(hyperedge) && continue
        root = first(hyperedge)
        for i in (firstindex(hyperedge) + 1):lastindex(hyperedge)
            union!(disjoint_sets, root, hyperedge[i])
        end
    end

    # maps the root of a vertex in `disjoint_sets` to the index of the corresponding set
    # in `vertex_sets`
    root_to_set = Dict{Int, Int}()
    vertex_sets = Vector{V}[]
    for (vert_i, vert) in enumerate(invmap)
        root = DataStructures.find_root!(disjoint_sets, vert_i)
        set_i = get!(root_to_set, root) do
            push!(vertex_sets, V[])
            return length(vertex_sets)
        end
        push!(vertex_sets[set_i], vert)
    end

    return vertex_sets
end

using BipartiteGraphs
using Test

@testset "Unassigned type" begin
    @test unassigned isa Unassigned
    @test length(unassigned) == 1
    @test size(unassigned) == ()
    @test collect(unassigned) == [unassigned]
end

@testset "Matching construction" begin
    # Test empty matching
    m = Matching(5)
    @test length(m) == 5
    @test all(x -> x === unassigned, m)

    # Test from vector
    v = Union{Int, Unassigned}[1, unassigned, 3, unassigned, 5]
    m = Matching(v)
    @test m[1] == 1
    @test m[2] === unassigned
    @test m[3] == 3

    integer_matching = Matching([1, 2, 3])
    @test integer_matching isa Matching{Unassigned, Vector{Int}}

    # Test type conversion
    m2 = Matching{Unassigned}(m)
    @test eltype(m2) == Union{Unassigned, Int}
end

@testset "`convert` methods" begin
    m = Matching(5)
    m[1] = 3
    m[2] = 4
    m2 = convert(
        Matching{
            Union{Unassigned, String}, Vector{Union{Unassigned, String, Int}},
        }, m
    )
    @test m2 isa Matching{Union{Unassigned, String}, Vector{Union{Unassigned, String, Int}}}
end

@testset "Matching operations" begin
    m = Matching(5)

    # Test setindex!
    m[1] = 2
    @test m[1] == 2
    m[2] = unassigned
    @test m[2] === unassigned

    # Test push!
    push!(m, 3)
    @test length(m) == 6
    @test m[6] == 3

    # Test copy
    m_copy = copy(m)
    m_copy[1] = 10
    @test m[1] == 2  # Original unchanged
    @test m_copy[1] == 10

    # Test iteration
    @test collect(m) isa Vector
end

@testset "Matching completion" begin
    m = Matching(5)
    m[1] = 2
    m[2] = 1
    m[3] = 3

    # Complete the matching
    m_complete = complete(m, 3)
    @test m_complete.inv_match !== nothing
    @test m_complete.inv_match[2] == 1
    @test m_complete.inv_match[1] == 2
    @test m_complete.inv_match[3] == 3

    # Test invview
    m_inv = invview(m_complete)
    @test m_inv[2] == 1
    @test m_inv[1] == 2
end

@testset "Matching with inverse" begin
    m = Matching(5)
    m_complete = complete(m, 5)

    # Setting with inverse should update both
    m_complete[1] = 2
    @test m_complete[1] == 2
    @test m_complete.inv_match[2] == 1

    m_complete[1] = 3
    @test m_complete[1] == 3
    @test m_complete.inv_match[3] == 1
    @test m_complete.inv_match[2] === unassigned
end

@testset "Matching with custom unassigned type" begin
    m = Matching{Symbol}(3)
    @test length(m) == 3
    @test all(x -> x === unassigned, m)
end

@testset "Push! with inverse matching" begin
    m = Matching(2)
    m = complete(m, 2)
    push!(m, 1)
    @test length(m) == 3
    @test m[3] == 1
    @test m.inv_match[1] == 3
end

@testset "Setindex! edge cases" begin
    m = Matching(3)
    m = complete(m, 3)

    # Set to a value beyond current inv_match length
    m[1] = 5
    @test m[1] == 5
    @test length(m.inv_match) >= 5

    # Reassign
    m[2] = 5
    @test m[2] == 5
    @test m[1] === unassigned  # Previous assignment should be unassigned
end

@testset "Matching require_complete" begin
    m = Matching(3)
    @test_throws ArgumentError require_complete(m)

    m_complete = complete(m)
    require_complete(m_complete)  # Should not throw
    @test true
end

module BipartiteGraphsSparseArraysExt

using BipartiteGraphs: BipartiteGraph, 𝑠vertices, 𝑠neighbors, nsrcs, ndsts
using Graphs: Graphs
using SparseArrays: sparse
using DocStringExtensions: TYPEDSIGNATURES

"""
    $TYPEDSIGNATURES

Obtain the incidence matrix for the [`BipartiteGraph`](@ref) `g`. `val` indicates the value
to be used in non-zero entries of the returned sparse matrix.
"""
function Graphs.incidence_matrix(g::BipartiteGraph, val = true)
    I = Int[]
    J = Int[]
    for i in 𝑠vertices(g), n in 𝑠neighbors(g, i)

        push!(I, i)
        push!(J, n)
    end
    return S = sparse(I, J, val, nsrcs(g), ndsts(g))
end

end

# API Reference

## Bipartite Graphs

```@docs
BipartiteEdge
Graphs.src(::BipartiteEdge)
Graphs.dst(::BipartiteEdge)
BipartiteGraphs.VertType
SRC
DST
BipartiteGraph
invview(::BipartiteGraph)
complete(::BipartiteGraph{I}) where {I}
require_complete(::BipartiteGraph)
Base.empty!(::BipartiteGraph)
𝑠vertices
𝑑vertices
has_𝑠vertex
has_𝑑vertex
𝑠neighbors
𝑑neighbors
𝑠edges
𝑑edges
Graphs.edges(::BipartiteGraph)
nsrcs
ndsts
Graphs.nv(::BipartiteGraph)
Graphs.vertices(::BipartiteGraph)
Graphs.add_edge!(::BipartiteGraph, ::Integer, ::Integer)
Graphs.add_edge!(::BipartiteGraph, ::BipartiteEdge)
Graphs.rem_edge!(::BipartiteGraph, ::Integer, ::Integer)
Graphs.rem_edge!(::BipartiteGraph, ::BipartiteEdge)
Graphs.add_vertex!(::BipartiteGraph{T}, ::BipartiteGraphs.VertType) where {T}
set_neighbors!
delete_srcs!
delete_dsts!
Graphs.incidence_matrix(::BipartiteGraph, ::Any)
```

## Maximal matching

```@docs
maximal_matching
construct_augmenting_path!
Matching
Unassigned
unassigned
Base.setindex!(::Matching{U}, ::Union{Integer, U}, ::Integer) where {U}
Base.push!(::Matching, ::Any)
complete(::Matching{U}, ::Any) where {U}
require_complete(::Matching)
invview(::Matching{U, V}) where {U, V}
```

## `DiCMOBiGraph`

```@docs
DiCMOBiGraph
DiCMOBiGraph{Transposed}(::BipartiteGraph) where {Transposed}
DiCMOBiGraph{Transposed}(::BipartiteGraph, ::M) where {Transposed, M}
invview(::DiCMOBiGraph{Transposed}) where {Transposed}
```

## Condensation graphs

```@docs
BipartiteGraphs.AbstractCondensationGraph
Graphs.nv(::BipartiteGraphs.AbstractCondensationGraph)
InducedCondensationGraph
MatchedCondensationGraph
```

## Hyper-graphs

```@docs
HyperGraph
HyperEdge
HyperGraphEdge
Graphs.add_vertex!(::HyperGraph{V}, ::V) where {V}
Graphs.add_edge!(::HyperGraph{V}, ::BipartiteGraphs.HyperGraphEdge{V}) where {V}
Graphs.vertices(::HyperGraph)
Graphs.nv(::HyperGraph)
Graphs.has_vertex(::HyperGraph{V}, ::V) where {V}
Graphs.ne(::HyperGraph)
Graphs.has_edge(::HyperGraph{V}, ::HyperEdge{V}) where {V}
Graphs.rem_edge!(::HyperGraph, ::HyperEdge)
Graphs.edges(::HyperGraph{V}) where {V}
Base.empty!(::HyperGraph)
Graphs.connected_components(::HyperGraph{V}) where {V}
neighbors
incident_edges
```
